initBehaviors() {
	buttonNormalSwitch = layoutMainNormal.findObject("player.button.switch");
	buttonMiniSwitch = layoutMainMini.findObject("player.button.switch");
	buttonStickSwitch = layoutMainStick.findObject("player.button.switch");
	
	buttonAlwaysOnTop = layoutMainNormal.findObject("player.button.aot");
	buttonInfoEditor= layoutMainNormal.findObject("player.button.infoeditor");
	
	buttonAutoAlwaysOnTop = layoutMainNormal.findObject("player.button.autoaot");
	buttonAutoSwitchLCD = layoutMainNormal.findObject("player.button.autoswitchlcd");
	
	buttonAutoAlwaysOnTopHelp = layoutMainNormal.findObject("player.button.autoaot.help");
	buttonAutoSwitchLCDHelp = layoutMainNormal.findObject("player.button.autoswitchlcd.help");
	
	buttonNormalPlay = layoutMainNormal.findObject("player.button.play");
	buttonNormalPause = layoutMainNormal.findObject("player.button.pause");
	buttonNormalStop = layoutMainNormal.findObject("player.button.stop");
	
	layerButtonNormalPlayOver = layoutMainNormal.findObject("player.button.play.over");
	layerButtonNormalPauseOver = layoutMainNormal.findObject("player.button.pause.over");
	layerButtonNormalStopOver = layoutMainNormal.findObject("player.button.stop.over");
	
	boolAutoAlwaysOnTop = System.getPrivateInt(strSkinName, "AutoAlwaysOnTop", 1);
	boolAutoSwitchLCD = System.getPrivateInt(strSkinName, "AutoSwitchLCD", 1);
	
	buttonAutoAlwaysOnTop.setActivated(boolAutoAlwaysOnTop);
	buttonAutoSwitchLCD.setActivated(boolAutoSwitchLCD);
}

unloadBehaviors() {
	delete buttonInfoEditor;
}

buttonAutoAlwaysOnTop.onToggle(Boolean boolActivate) {
	boolAutoAlwaysOnTop = boolActivate;
	System.setPrivateInt(strSkinName, "AutoAlwaysOnTop", boolAutoAlwaysOnTop);
}

buttonAutoSwitchLCD.onToggle(Boolean boolActivate) {
	boolAutoSwitchLCD = boolActivate;
	System.setPrivateInt(strSkinName, "AutoSwitchLCD", boolAutoSwitchLCD);
}

buttonAutoAlwaysOnTopHelp.onLeftClick() {
	messageBox("Always On Top Stick Mode:\nEnabling this option forces Invicta's stick mode to always be on top\nregardless of the setting currently selected in Winamp's preferences.", "Help", 0, "");
}

buttonAutoSwitchLCDHelp.onLeftClick() {
	messageBox("Autoswitch LCD:\nEnabling this option will cause the main player LCD to\nrevert to it's normal mode when closing the top drawer.", "Help", 0, "");
}

containerMain.onSwitchToLayout(Layout layoutMainCurrent) {
	String strLayoutPrevious;
	Int intPreviousAlwaysOnTop;
	Int intCurrentAlwaysOnTop;
	Int intLayoutLeft;
	Int intLayoutTop;
	Int intLayoutHeight;
	
	strLayoutPrevious = System.getPrivateString(strSkinName, "LayoutMainPrevious", "layoutMainNormal");
	intPreviousAlwaysOnTop = System.getPrivateInt(strSkinName, "LayoutMainPreviousAOT", 1);
	intCurrentAlwaysOnTop = buttonAlwaysOnTop.getActivated();
	
	if (strLayoutPrevious == "layoutMainNormal") {
		System.setPrivateInt(strSkinName, "LayoutMainNormalTop", layoutMainNormal.getTop());
		System.setPrivateInt(strSkinName, "LayoutMainNormalLeft", layoutMainNormal.getLeft());
	}
	if (strLayoutPrevious == "layoutMainMini") {
		System.setPrivateInt(strSkinName, "LayoutMainMiniTop", layoutMainMini.getTop());
		System.setPrivateInt(strSkinName, "LayoutMainMiniLeft", layoutMainMini.getLeft());
	}
	if (strLayoutPrevious == "layoutMainStick") {
		System.setPrivateInt(strSkinName, "LayoutMainStickTop", layoutMainStick.getTop());
		System.setPrivateInt(strSkinName, "LayoutMainStickLeft", layoutMainStick.getLeft());
	}
	
	if (layoutMainCurrent == layoutMainNormal) {
		intLayoutTop = System.getPrivateInt(strSkinName, "LayoutMainNormalTop", ((System.getViewportHeight() / 2) - (layoutMainNormal.getHeight() / 2)));
		intLayoutLeft = System.getPrivateInt(strSkinName, "LayoutMainNormalLeft", ((System.getViewportWidth() / 2) - (layoutMainNormal.getWidth() / 2)));
		layoutMainNormal.resize(intLayoutLeft, intLayoutTop, layoutMainNormal.getWidth(), layoutMainNormal.getHeight());
		if (boolAutoAlwaysOnTop) {
			if (strLayoutPrevious == "layoutMainStick" && intPreviousAlwaysOnTop == 0 && intCurrentAlwaysOnTop == 1) {
				buttonAlwaysOnTop.leftClick();
			}
		}
		System.setPrivateString(strSkinName, "LayoutMainPrevious", "layoutMainNormal");
		System.setPrivateInt(strSkinName, "LayoutMainPreviousAOT", buttonAlwaysOnTop.getActivated());
		return;
	}
	if (layoutMainCurrent == layoutMainMini) {
		intLayoutTop = System.getPrivateInt(strSkinName, "LayoutMainMiniTop", ((System.getViewportHeight() / 2) - (layoutMainMini.getHeight() / 2)));
		intLayoutLeft = System.getPrivateInt(strSkinName, "LayoutMainMiniLeft", ((System.getViewportWidth() / 2) - (layoutMainMini.getWidth() / 2)));
		layoutMainMini.resize(intLayoutLeft, intLayoutTop, layoutMainMini.getWidth(), layoutMainMini.getHeight());
		if (boolAutoAlwaysOnTop) {
			if (strLayoutPrevious == "layoutMainStick" && intPreviousAlwaysOnTop == 0 && intCurrentAlwaysOnTop == 1) {
				buttonAlwaysOnTop.leftClick();
			}
		}
		System.setPrivateString(strSkinName, "LayoutMainPrevious", "layoutMainMini");
		System.setPrivateInt(strSkinName, "LayoutMainPreviousAOT", buttonAlwaysOnTop.getActivated());
		return;
	}
	if (layoutMainCurrent == layoutMainStick) {
		intLayoutTop = System.getPrivateInt(strSkinName, "LayoutMainStickTop", 0);
		intLayoutLeft = System.getPrivateInt(strSkinName, "LayoutMainStickLeft", ((System.getViewportWidth() / 2) - (layoutMainStick.getWidth() / 2)));
		layoutMainStick.resize(intLayoutLeft, intLayoutTop, layoutMainStick.getWidth(), layoutMainStick.getHeight());
		System.setPrivateString(strSkinName, "LayoutMainPrevious", "layoutMainStick");
		System.setPrivateInt(strSkinName, "LayoutMainPreviousAOT", buttonAlwaysOnTop.getActivated());
		if (boolAutoAlwaysOnTop) {
			if (intCurrentAlwaysOnTop == 0) {
				buttonAlwaysOnTop.leftClick();
			}
		}
		return;
	}
}

buttonNormalSwitch.onRightClick() { buttonSwitchRightClickUtil(); }
buttonMiniSwitch.onRightClick() { buttonSwitchRightClickUtil(); }
buttonStickSwitch.onRightClick() { buttonSwitchRightClickUtil(); }

buttonNormalSwitch.onRightButtonUp(Int intPosX, Int intPosY) { complete;}
buttonMiniSwitch.onRightButtonUp(Int intPosX, Int intPosY) { complete;}
buttonStickSwitch.onRightButtonUp(Int intPosX, Int intPosY) { complete;}

buttonSwitchRightClickUtil() {
	PopupMenu popupMenuSwitch;
	
	popupMenuSwitch = new PopupMenu;
	popupMenuSwitch.addCommand("Normal ", 1, (layoutMainNormal.isVisible()), 0);
	popupMenuSwitch.addCommand("Mini ", 2, (layoutMainMini.isVisible()), 0);
	popupMenuSwitch.addCommand("Stick ", 3, (layoutMainStick.isVisible()), 0);
	
	if (popupMenuSwitch == NULL) { return; }
	Int intSelection = popupMenuSwitch.popAtMouse();
	if (intSelection > 0) {
		if (intSelection == 1) { containerMain.switchToLayout("NORMAL"); }
		if (intSelection == 2) { containerMain.switchToLayout("MINI"); }
		if (intSelection == 3) { containerMain.switchToLayout("STICK"); }
	}
	complete;
	
	delete popupMenuSwitch;
}

textNormalSongName.onLeftButtonDblClk(Int intX, Int intY) { buttonInfoEditor.leftClick(); }
textMiniSongName.onLeftButtonDblClk(Int intX, Int intY) { buttonInfoEditor.leftClick(); }
textStickSongName.onLeftButtonDblClk(Int intX, Int intY) {
	timerTextStickSongNameSingleClick.stop();
	buttonInfoEditor.leftClick();
}

buttonNormalPlay.onEnterArea() {
	layerButtonNormalPlayOver.setTargetA(255);
	layerButtonNormalPlayOver.setTargetSpeed(0.5);
	layerButtonNormalPlayOver.gotoTarget();
}

buttonNormalPlay.onLeaveArea() {
	layerButtonNormalPlayOver.setTargetA(0);
	layerButtonNormalPlayOver.setTargetSpeed(0.5);
	layerButtonNormalPlayOver.gotoTarget();
}

buttonNormalPlay.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerButtonNormalPlayOver.hide();
}

buttonNormalPlay.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerButtonNormalPlayOver.show();
}

buttonNormalPause.onEnterArea() {
	layerButtonNormalPauseOver.setTargetA(255);
	layerButtonNormalPauseOver.setTargetSpeed(0.5);
	layerButtonNormalPauseOver.gotoTarget();
}

buttonNormalPause.onLeaveArea() {
	layerButtonNormalPauseOver.setTargetA(0);
	layerButtonNormalPauseOver.setTargetSpeed(0.5);
	layerButtonNormalPauseOver.gotoTarget();
}

buttonNormalPause.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerButtonNormalPauseOver.hide();
}

buttonNormalPause.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerButtonNormalPauseOver.show();
}

buttonNormalStop.onEnterArea() {
	layerButtonNormalStopOver.setTargetA(255);
	layerButtonNormalStopOver.setTargetSpeed(0.5);
	layerButtonNormalStopOver.gotoTarget();
}

buttonNormalStop.onLeaveArea() {
	layerButtonNormalStopOver.setTargetA(0);
	layerButtonNormalStopOver.setTargetSpeed(0.5);
	layerButtonNormalStopOver.gotoTarget();
}

buttonNormalStop.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerButtonNormalStopOver.hide();
}

buttonNormalStop.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerButtonNormalStopOver.show();
}

textNormalSongName.onRightButtonDown(Int intPosX, Int intPosY) { txtSongNameRightButtonDownUtil(); }
textMiniSongName.onRightButtonDown(Int intPosX, Int intPosY) { txtSongNameRightButtonDownUtil(); }
textStickSongName.onRightButtonDown(Int intPosX, Int intPosY) { txtSongNameRightButtonDownUtil(); }

txtSongNameRightButtonDownUtil() {
	PopupMenu popupMenuSongTicker;
	
	popupMenuSongTicker = new PopupMenu;
	popupMenuSongTicker.addCommand("Song Ticker Scrolling", -1, 0, 1);
	popupMenuSongTicker.addSeparator();
	popupMenuSongTicker.addCommand("Enabled ", 1, (boolSongTicker == 1), 0);
	popupMenuSongTicker.addCommand("Disabled", 0, (boolSongTicker == 0), 0);
	
	Int intResult = popupMenuSongTicker.popAtMouse();
	
	if (intResult > -1) {
		boolSongTicker = intResult;
		setSongTicker();
	}
	
	complete;
	
	delete popupMenuSongTicker;
}