initCrossfader() {
	layerNormalCrossfaderDigits = layoutMainNormal.findObject("player.display.modeconfigure.crossfade.digits");
	buttonNormalCrossfadeDecrease = layoutMainNormal.findObject("player.button.crossfade.decrease");
	buttonNormalCrossfadeIncrease = layoutMainNormal.findObject("player.button.crossfade.increase");
	
	layerStickCrossfaderDigits = layoutMainStick.findObject("player.display.crossfade.digits");
	buttonStickCrossfadeDecrease = layoutMainStick.findObject("player.button.crossfade.decrease");
	buttonStickCrossfadeIncrease = layoutMainStick.findObject("player.button.crossfade.increase");
	
	createSliderCrossfade(layoutMainNormal);
	
	intCrossfaderDigitWidth = 15;
	intCurrentCrossfade = (sliderCrossfade.getPosition());
	
	syncCrossfader(intCurrentCrossfade);
}

unloadCrossfader() {
	delete sliderCrossfade;
}

buttonNormalCrossfadeDecrease.onLeftClick() { buttonCrossfadeDecreaseLeftClickUtil(); }
buttonStickCrossfadeDecrease.onLeftClick() { buttonCrossfadeDecreaseLeftClickUtil(); }

buttonCrossfadeDecreaseLeftClickUtil() {
	intCurrentCrossfade = intCurrentCrossfade - 1;
	if (intCurrentCrossfade < 0) intCurrentCrossfade = 0;
	sliderCrossfade.setPosition(intCurrentCrossfade + 1);
	syncCrossfader(intCurrentCrossfade);
}

buttonNormalCrossfadeIncrease.onLeftClick() { buttonCrossfadeIncreaseLeftClickUtil(); }
buttonStickCrossfadeIncrease.onLeftClick() { buttonCrossfadeIncreaseLeftClickUtil(); }

buttonCrossfadeIncreaseLeftClickUtil() {
	intCurrentCrossfade = intCurrentCrossfade + 1;
	if (intCurrentCrossfade > 20) intCurrentCrossfade = 20;
	sliderCrossfade.setPosition(intCurrentCrossfade + 1);
	syncCrossfader(intCurrentCrossfade);
}

syncCrossfader(Int intPosition) {
	syncNormalCrossfader(intPosition);
	syncStickCrossfader(intPosition);
}

syncNormalCrossfader(Int intPosition) {
	layerNormalCrossfaderDigits.setTargetX(intPosition * (intCrossfaderDigitWidth * -1));
	layerNormalCrossfaderDigits.setTargetSpeed(0.5);
	layerNormalCrossfaderDigits.gotoTarget();
}

syncStickCrossfader(Int intPosition) {
	layerStickCrossfaderDigits.setTargetX(intPosition * (intCrossfaderDigitWidth * -1));
	layerStickCrossfaderDigits.setTargetSpeed(0.5);
	layerStickCrossfaderDigits.gotoTarget();
}

createSliderCrossfade(Layout layoutParent) {
	sliderCrossfade = new Slider;
	sliderCrossfade.setXMLParam("cfgattrib", "{F1239F09-8CC6-4081-8519-C2AE99FCB14C};Crossfade time");
	sliderCrossfade.setXMLParam("x", "-21");
	sliderCrossfade.setXMLParam("y", "-13");
	sliderCrossfade.setXMLParam("w", "21");
	sliderCrossfade.setXMLParam("h", "13");
	sliderCrossfade.setXMLParam("low", "0");
	sliderCrossfade.setXMLParam("high", "20");
	sliderCrossfade.init(layoutParent);
}