initCustomButtons() {
	buttonNormalCustomOne = layoutMainNormal.findObject("player.button.custom.one");
	buttonNormalCustomTwo = layoutMainNormal.findObject("player.button.custom.two");
	buttonMiniCustomOne = layoutMainMini.findObject("player.button.custom.one");
	buttonMiniCustomTwo = layoutMainMini.findObject("player.button.custom.two");
	buttonStickCustomOne = layoutMainStick.findObject("player.button.custom.one");
	buttonStickCustomTwo = layoutMainStick.findObject("player.button.custom.two");

	buttonCustomOneLeft = layoutMainNormal.findObject("player.button.remap.one.decrease");
	buttonCustomOneRight = layoutMainNormal.findObject("player.button.remap.one.increase");
	buttonCustomTwoLeft = layoutMainNormal.findObject("player.button.remap.two.decrease");
	buttonCustomTwoRight = layoutMainNormal.findObject("player.button.remap.two.increase");
	
	layerCustomButtonOneOptions = layoutMainNormal.findObject("player.display.modeconfigure.custombutton.one.options");
	layerCustomButtonTwoOptions = layoutMainNormal.findObject("player.display.modeconfigure.custombutton.two.options");
	
	intCustomButtonOptionCount = 8;
	
	strTokenRowDelimeter = "|";
	strTokenColumnDelimeter = ";";
	
	strCustomButtonOptions = strCustomButtonOptions + "Playlist Editor" + strTokenColumnDelimeter + "guid:PL" + strTokenRowDelimeter;
	strCustomButtonOptions = strCustomButtonOptions + "Media Library" + strTokenColumnDelimeter + "guid:ML" + strTokenRowDelimeter;
	strCustomButtonOptions = strCustomButtonOptions + "Preferences" + strTokenColumnDelimeter + "guid:{B397A4CE-455A-4D62-8BF6-D0F91ACB70E6}" + strTokenRowDelimeter;
	strCustomButtonOptions = strCustomButtonOptions + "AVS" + strTokenColumnDelimeter + "guid:{0000000A-000C-0010-FF7B-01014263450C}" + strTokenRowDelimeter;
	strCustomButtonOptions = strCustomButtonOptions + "Video" + strTokenColumnDelimeter + "guid:{F0816D7B-FFFC-4343-80F2-E8199AA15CC3}" + strTokenRowDelimeter;
	strCustomButtonOptions = strCustomButtonOptions + "Color Themes" + strTokenColumnDelimeter + "colorthemes" + strTokenRowDelimeter;
	strCustomButtonOptions = strCustomButtonOptions + "Skin Tips" + strTokenColumnDelimeter + "tips" + strTokenRowDelimeter;
	strCustomButtonOptions = strCustomButtonOptions + "Check for Updates" + strTokenColumnDelimeter + "updater";
	
	intCustomButtonOneCurrentOption = System.getPrivateInt(strSkinName, "CustomButtonOneCurrentOption", 0);
	intCustomButtonTwoCurrentOption = System.getPrivateInt(strSkinName, "CustomButtonTwoCurrentOption", 1);

	syncCustomButtonConfiguration(buttonNormalCustomOne, intCustomButtonOneCurrentOption, layerCustomButtonOneOptions);
	syncCustomButtonConfiguration(buttonNormalCustomTwo, intCustomButtonTwoCurrentOption, layerCustomButtonTwoOptions);
	syncCustomButtonConfiguration(buttonMiniCustomOne, intCustomButtonOneCurrentOption, layerCustomButtonOneOptions);
	syncCustomButtonConfiguration(buttonMiniCustomTwo, intCustomButtonTwoCurrentOption, layerCustomButtonTwoOptions);
	syncCustomButtonConfiguration(buttonStickCustomOne, intCustomButtonOneCurrentOption, layerCustomButtonOneOptions);
	syncCustomButtonConfiguration(buttonStickCustomTwo, intCustomButtonTwoCurrentOption, layerCustomButtonTwoOptions);
}

buttonCustomOneLeft.onLeftClick() {
	intCustomButtonOneCurrentOption = intCustomButtonOneCurrentOption - 1;
	if (intCustomButtonOneCurrentOption < 0) intCustomButtonOneCurrentOption = 0;
	System.setPrivateInt(strSkinName, "CustomButtonOneCurrentOption", intCustomButtonOneCurrentOption);
	syncCustomButtonConfiguration(buttonNormalCustomOne, intCustomButtonOneCurrentOption, layerCustomButtonOneOptions);
}

buttonCustomOneRight.onLeftClick() {
	intCustomButtonOneCurrentOption = intCustomButtonOneCurrentOption + 1;
	if (intCustomButtonOneCurrentOption > (intCustomButtonOptionCount - 1)) intCustomButtonOneCurrentOption = (intCustomButtonOptionCount - 1);
	System.setPrivateInt(strSkinName, "CustomButtonOneCurrentOption", intCustomButtonOneCurrentOption);
	syncCustomButtonConfiguration(buttonNormalCustomOne, intCustomButtonOneCurrentOption, layerCustomButtonOneOptions);
}

buttonCustomTwoLeft.onLeftClick() {
	intCustomButtonTwoCurrentOption = intCustomButtonTwoCurrentOption - 1;
	if (intCustomButtonTwoCurrentOption < 0) intCustomButtonTwoCurrentOption = 0;
	System.setPrivateInt(strSkinName, "CustomButtonTwoCurrentOption", intCustomButtonTwoCurrentOption);
	syncCustomButtonConfiguration(buttonNormalCustomTwo, intCustomButtonTwoCurrentOption, layerCustomButtonTwoOptions);
}

buttonCustomTwoRight.onLeftClick() {
	intCustomButtonTwoCurrentOption = intCustomButtonTwoCurrentOption + 1;
	if (intCustomButtonTwoCurrentOption > (intCustomButtonOptionCount - 1)) intCustomButtonTwoCurrentOption = (intCustomButtonOptionCount - 1);
	System.setPrivateInt(strSkinName, "CustomButtonTwoCurrentOption", intCustomButtonTwoCurrentOption);
	syncCustomButtonConfiguration(buttonNormalCustomTwo, intCustomButtonTwoCurrentOption, layerCustomButtonTwoOptions);
}

buttonNormalCustomOne.onRightClick() { buttonCustomOneRightClickUtil(buttonNormalCustomOne); }
buttonMiniCustomOne.onRightClick() { buttonCustomOneRightClickUtil(buttonMiniCustomOne); }
buttonStickCustomOne.onRightClick() { buttonCustomOneRightClickUtil(buttonStickCustomOne); }

buttonCustomOneRightClickUtil(Button buttonCustomOne) {
	PopupMenu popupMenuCustomButtonModes;
	
	popupMenuCustomButtonModes = new PopupMenu;
	popupMenuCustomButtonModes.addCommand("Available Modes", -1, 0, 1);
	popupMenuCustomButtonModes.addSeparator();
	for (Int intCustomButtonOptionRow = 0; intCustomButtonOptionRow <= (intCustomButtonOptionCount - 1); intCustomButtonOptionRow++) {
		popupMenuCustomButtonModes.addCommand(System.getToken(System.getToken(strCustomButtonOptions, strTokenRowDelimeter, intCustomButtonOptionRow), strTokenColumnDelimeter, 0), intCustomButtonOptionRow, (intCustomButtonOneCurrentOption == intCustomButtonOptionRow), 0);
	}
	
	String strTempTooltip = buttonCustomOne.getXMLParam("TOOLTIP");
	buttonCustomOne.setXMLParam("TOOLTIP", "");
	Int intCustomButtonSelectedOption = popupMenuCustomButtonModes.popAtMouse();
	if (intCustomButtonSelectedOption > -1) {
		intCustomButtonOneCurrentOption = intCustomButtonSelectedOption;
		System.setPrivateInt(strSkinName, "CustomButtonOneCurrentOption", intCustomButtonOneCurrentOption);
		syncCustomButtonConfiguration(buttonNormalCustomOne, intCustomButtonOneCurrentOption, layerCustomButtonOneOptions);
		syncCustomButtonConfiguration(buttonMiniCustomOne, intCustomButtonOneCurrentOption, layerCustomButtonOneOptions);
		syncCustomButtonConfiguration(buttonStickCustomOne, intCustomButtonOneCurrentOption, layerCustomButtonOneOptions);
	} else {
		buttonCustomOne.setXMLParam("TOOLTIP", strTempTooltip);
	}
	
	delete popupMenuCustomButtonModes;
}

buttonNormalCustomTwo.onRightClick() { buttonCustomTwoRightClickUtil(buttonNormalCustomTwo); }
buttonMiniCustomTwo.onRightClick() { buttonCustomTwoRightClickUtil(buttonMiniCustomTwo); }
buttonStickCustomTwo.onRightClick() { buttonCustomTwoRightClickUtil(buttonStickCustomTwo); }

buttonCustomTwoRightClickUtil(Button buttonCustomTwo) {
	PopupMenu popupMenuCustomButtonModes;
	
	popupMenuCustomButtonModes = new PopupMenu;
	popupMenuCustomButtonModes.addCommand("Available Modes", -1, 0, 1);
	popupMenuCustomButtonModes.addSeparator();
	for (Int intCustomButtonOptionRow = 0; intCustomButtonOptionRow <= (intCustomButtonOptionCount - 1); intCustomButtonOptionRow++) {
		popupMenuCustomButtonModes.addCommand(System.getToken(System.getToken(strCustomButtonOptions, strTokenRowDelimeter, intCustomButtonOptionRow), strTokenColumnDelimeter, 0), intCustomButtonOptionRow, (intCustomButtonTwoCurrentOption == intCustomButtonOptionRow), 0);
	}
	
	String strTempTooltip = buttonCustomTwo.getXMLParam("TOOLTIP");
	buttonCustomTwo.setXMLParam("TOOLTIP", "");
	Int intCustomButtonSelectedOption = popupMenuCustomButtonModes.popAtMouse();
	if (intCustomButtonSelectedOption > -1) {
		intCustomButtonTwoCurrentOption = intCustomButtonSelectedOption;
		System.setPrivateInt(strSkinName, "CustomButtonTwoCurrentOption", intCustomButtonTwoCurrentOption);
		syncCustomButtonConfiguration(buttonNormalCustomTwo, intCustomButtonTwoCurrentOption, layerCustomButtonTwoOptions);
		syncCustomButtonConfiguration(buttonMiniCustomTwo, intCustomButtonTwoCurrentOption, layerCustomButtonTwoOptions);
		syncCustomButtonConfiguration(buttonStickCustomTwo, intCustomButtonTwoCurrentOption, layerCustomButtonTwoOptions);
	} else {
		buttonCustomTwo.setXMLParam("TOOLTIP", strTempTooltip);
	}
	
	delete popupMenuCustomButtonModes;
}

buttonNormalCustomOne.onRightButtonUp(Int intPosX, Int intPosY) { complete;}
buttonNormalCustomTwo.onRightButtonUp(Int intPosX, Int intPosY) { complete;}
buttonMiniCustomOne.onRightButtonUp(Int intPosX, Int intPosY) { complete;}
buttonMiniCustomTwo.onRightButtonUp(Int intPosX, Int intPosY) { complete;}
buttonStickCustomOne.onRightButtonUp(Int intPosX, Int intPosY) { complete;}
buttonStickCustomTwo.onRightButtonUp(Int intPosX, Int intPosY) { complete;}

syncCustomButtonConfiguration(Button buttonCustom, Int intCustomButtonCurrentOption, Layer layerCustomButtonOptions) {
	String strCurrentOptionData;
	String strCurrentOptionName;
	String strCurrentOptionGUID;
	Int intOptionWidth = 33;
	
	strCurrentOptionData = System.getToken(strCustomButtonOptions, "|", intCustomButtonCurrentOption);
	strCurrentOptionName = System.getToken(strCurrentOptionData, ";", 0);
	strCurrentOptionGUID = System.getToken(strCurrentOptionData, ";", 1);
	
	buttonCustom.setXMLParam("PARAM", strCurrentOptionGUID);
	buttonCustom.setXMLParam("TOOLTIP", strCurrentOptionName + " (Right-click to change function)");
	
	layerCustomButtonOptions.setTargetX(intCustomButtonCurrentOption * (intOptionWidth * -1));
	layerCustomButtonOptions.setTargetSpeed(0.75);
	layerCustomButtonOptions.gotoTarget();
}