/************************************************
Function Declarations
************************************************/

// Global
Function initGlobal();
Function unloadGlobal();
Function showActionInfo(String strValue);
Function setSongTicker();
Function debugAlert(String strValue);

//Drawers
Function initDrawers();
Function unloadDrawers();

//Drawer Util
Function animateDrawer(Group groupDrawer, Int intTargetPositionY, Float floatSpeed);

//Drawer Normal
Function initNormalDrawers();
Function unloadNormalDrawers();
Function buttonNormalDrawerBottomToggleUpLeftButtonDownUtil();
Function buttonNormalDrawerBottomToggleDownLeftButtonDownUtil();

//Drawer Stick
Function initStickDrawers();
Function unloadStickDrawers();
Function initStickDrawerPL();
Function initStickDrawerConfig();
Function closeStickDrawer(Group groupDrawer, Int intDrawerPosYClosed);

//Pager
Function initPager();
Function gotoPage(Int intPage);
Function slidePage(Int intPosY);
Function setPager(Int intPage);

//Crossfader
Function initCrossfader();
Function unloadCrossfader();
Function buttonCrossfadeDecreaseLeftClickUtil();
Function buttonCrossfadeIncreaseLeftClickUtil();
Function createSliderCrossfade(Layout layoutParent);
Function syncCrossfader(Int intPosition);
Function syncNormalCrossfader(Int intPosition);
Function syncStickCrossfader(Int intPosition);

//Custom Buttons
Function initCustomButtons();
Function syncCustomButtonConfiguration(Button buttonCustom, Int intCustomButtonCurrentOption, Layer layerCustomButtonOptions);
Function buttonCustomOneRightClickUtil(Button buttonCustomOne);
Function buttonCustomTwoRightClickUtil(Button buttonCustomTwo);

//Lights
Function visLightsUpdate(Int intLeftValue, Int intRightValue);
Function visLightsUpdatePulse(Int intLeftValue, Int intRightValue);
Function visLightsUpdateLevel(Int intLeftValue, Int intRightValue);
Function initLights();
Function unloadLights();

//Seek
Function initSeek();
Function unloadSeek();
Function seekUpdate(Int intNewPosition);
Function seekUpdateUtil(Int intNewPosition, Map mapSeekRegion, Layer layerSeekGhost);
Function seekUpdateXY(Int intPosX, Int intPosY, Map mapSeekLevel, Map mapSeekRegion, Layer layerSeekGhost, Text textSongTicker, Text textSeekTicker);
Function seekUpdateRegion(Layer layerSeekGhost, Map mapSeekRegion, Float floatPosition);
Function seekMoveTo(Int intPosX, Int intPosY, Map mapSeekLevel);
Function layerSeekSurfaceLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapSeekLevel, Map mapSeekRegion, Layer layerSeekGhost, Text textSongTicker, Text textSeekTicker);
Function layerSeekSurfaceMouseMoveUtil(Int intPosX, Int intPosY, Map mapSeekLevel, Map mapSeekRegion, Layer layerSeekGhost, Text textSongTicker, Text textSeekTicker);
Function layerSeekSurfaceLeftButtonUpUtil(Int intPosX, Int intPosY, Map mapSeekLevel);

//Volume
Function initVolume();
Function volumeUpdate();
Function volumeUpdateUtil(Map mapVolumeRegion, Layer layerVolumeGhost);
Function volumeUpdateXY(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker);
Function volumeUpdateRegion(Layer layerVolumeGhost, Map mapVolumeRegion, Float floatVolume);
Function layerVolumeSurfaceLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker);
Function layerVolumeSurfaceMouseMoveUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker);
Function layerVolumeSurfaceLeftButtonUpUtil(Int intPosX, Int intPosY);
Function volumeUpdateTicker(Int intVolume, Text textSongTicker, Text textVolumeTicker);

//Song Time
Function initSongTime();
Function unloadSongTime();
Function setSongTime(Text textSongTime);
Function toggleSongTimeMode();

//Song Info
Function initSongInfo();
Function unloadSongInfo();
Function setSongInfo(Text textSongTime);
Function String getBitrate(String strSource);
Function String getChannel(String strSource);
Function String getFrequency(String strSource);
Function String getTrackNumber();

//Behaviors
Function initBehaviors();
Function unloadBehaviors();
Function buttonSwitchRightClickUtil();
Function txtSongNameRightButtonDownUtil();

//Displays
Function initDisplays();

//Display Normal
Function initDisplayNormal();
Function startNormalDisplayTransition();
Function showNormalDisplayCurrentMode();
Function buttonNormalDisplayModeLeftClickUtil(String strNormalDisplayNewMode);

//Display Mini
Function initDisplayMini();
Function startMiniDisplayTransition();
Function showMiniDisplayCurrentMode();
Function buttonMiniDisplayModeLeftClickUtil(String strMiniDisplayNewMode);

//Visualizers
Function initVisualizers();
Function unloadVisualizers();
Function visRefreshUtil(AnimatedLayer layerVis, Boolean boolVisEnabled);

//Tips
Function initTips();
Function showTip(Int intTipIndex);
Function String getTipSection(Int intTipIndex);


/************************************************
Variable Declarations
************************************************/

//Global
Global String strSkinName;
Global Container containerMain;
Global Layout layoutMainNormal;
Global Layout layoutMainMini;
Global Layout layoutMainStick;
Global Text textNormalSongTime, textMiniSongTime, textStickSongTime;
Global Text textNormalSongName, textMiniSongName, textStickSongName;
Global Text textNormalSongInfo;
Global Text textNormalActionInfo, textMiniActionInfo, textStickActionInfo;
Global Timer timerSongTicker;
Global Boolean boolReleaseSongTicker;
Global Boolean boolSongTicker;
Global Map mapNormalVolSeekLevel, mapNormalVolSeekRegion;
Global Map mapMiniVolSeekLevel, mapMiniVolSeekRegion;
Global Map mapStickVolSeekLevel, mapStickVolumeRegion, mapStickSeekRegion;
Global Region regionVolSeekPosition;

//Drawer Normal
Global Group groupNormalDrawerTop, groupNormalDrawerBottom;
Global Button buttonNormalDrawerTopToggle;
Global Button buttonNormalDrawerBottomToggleUp, buttonNormalDrawerBottomToggleDown;
Global Int intNormalDrawerTopPosYLow, intNormalDrawerTopPosYHigh;
Global Int intNormalDrawerBottomPosYLow, intNormalDrawerBottomPosYMid, intNormalDrawerBottomPosYHigh;
Global Timer timerNormalDrawerSingleClick;
Global String strNormalDrawerBottomCurrentToggleID;

//Drawer Stick
Global Group groupStickDrawerPL;
Global Group groupStickDrawerPLComponents;
Global Group groupStickDrawerConfig;
Global Layout layoutStickDrawerPLComponents;
Global Layer layerStickDrawerPLBackground;
Global Layer layerStickDrawerConfigBackground;
Global ToggleButton buttonStickDrawerPLToggle;
Global ToggleButton buttonStickDrawerConfigToggle;
Global AnimatedLayer layerStickDrawerPLToggle;
Global AnimatedLayer layerStickDrawerConfigToggle;
Global Int intStickDrawerPLPosYLow;
Global Int intStickDrawerConfigPosYLow, intStickDrawerConfigPosYHigh;
Global String strStickDrawerLastPosition;
Global Timer timerTextStickSongNameSingleClick;
Global Int intTextStickSongNameLeftButtonDown;

//Pager
Global Group groupPageBinder;
Global Group groupPageOne, groupPageTwo, groupPageThree, groupPageFour;
Global Button buttonPagerOne, buttonPagerTwo, buttonPagerThree, buttonPagerFour;
Global Button buttonPagerLeft, buttonPagerRight;
Global Int intPagerCurrentPage;
Global Int intPageBinderPageOnePosY, intPageBinderPageTwoPosY, intPageBinderPageThreePosY, intPageBinderPageFourPosY;

//Crossfader
Global Layer layerNormalCrossfaderDigits;
Global Layer layerStickCrossfaderDigits;
Global Button buttonNormalCrossfadeDecrease, buttonNormalCrossfadeIncrease;
Global Button buttonStickCrossfadeDecrease, buttonStickCrossfadeIncrease;
Global Slider sliderCrossfade;
Global Int intCurrentCrossfade;
Global Int intCrossfaderDigitWidth;

//Custom Buttons
Global Button buttonNormalCustomOne, buttonNormalCustomTwo;
Global Button buttonMiniCustomOne, buttonMiniCustomTwo;
Global Button buttonStickCustomOne, buttonStickCustomTwo;
Global Button buttonCustomOneLeft, buttonCustomOneRight;
Global Button buttonCustomTwoLeft, buttonCustomTwoRight;
Global Layer layerCustomButtonOneOptions, layerCustomButtonTwoOptions;
Global String strCustomButtonOptions;
Global String strTokenRowDelimeter;
Global String strTokenColumnDelimeter;
Global Int intCustomButtonOneCurrentOption, intCustomButtonTwoCurrentOption;
Global Int intCustomButtonOptionCount;

//Lights
Global Layer layerNormalLightsLeft;
Global Layer layerNormalLightsRight;
Global Layer layerNormalLightsHint;
Global Map mapNormalLightsLevel;
Global Region regionNormalLightsLevel;
Global Timer timerLights;
Global String strLightsCurrentMode;

//Seek
Global Layer layerNormalSeekSurface, layerNormalSeekGhost;
Global Layer layerMiniSeekSurface, layerMiniSeekGhost;
Global Layer layerStickSeekSurface, layerStickSeekGhost;
Global Int intSeekClicked;
Global Timer timerSeek;
Global Int intCurrentPosition;

//Volume
Global Layer layerNormalVolumeSurface, layerNormalVolumeGhost;
Global Layer layerMiniVolumeSurface, layerMiniVolumeGhost;
Global Layer layerStickVolumeSurface, layerStickVolumeGhost;
Global Int intVolumeClicked;
Global Int intCurrentVolume;

//Song Time
Global Timer timerSongTime;
Global String strSongTimeMode;
Global Layer layerNormalTimeElapsed, layerNormalTimeRemaining;
Global Layer layerMiniTimeElapsed, layerMiniTimeRemaining;

//Song Info
Global Timer timerSongInfo;
Global String strSongInfoMode;
Global Text textSongInfoSource;

//Behaviors
Global Button buttonNormalSwitch, buttonMiniSwitch, buttonStickSwitch;
Global Button buttonAlwaysOnTop;
Global ToggleButton buttonAutoAlwaysOnTop;
Global ToggleButton buttonAutoSwitchLCD;
Global Button buttonAutoAlwaysOnTopHelp;
Global Button buttonAutoSwitchLCDHelp;
Global Button buttonNormalPlay, buttonNormalPause, buttonNormalStop;
Global Layer layerButtonNormalPlayOver, layerButtonNormalPauseOver, layerButtonNormalStopOver;
Global Button buttonInfoEditor;
Global Boolean boolAutoAlwaysOnTop;
Global Boolean boolAutoSwitchLCD;

//Display Normal
Global Group groupNormalDisplayNormal;
Global Group groupNormalDisplayEqualizer;
Global Group groupNormalDisplayConfigure;
Global Layer layerNormalDisplayTransition;
Global Button buttonNormalDisplayEqualizer;
Global Button buttonNormalDisplayConfigure;
Global Button buttonNormalDisplayNormal;
Global String strNormalDisplayCurrentMode;
Global String strNormalDisplayTransitionStatus;

//Display Mini
Global Group groupMiniDisplayNormal;
Global Group groupMiniDisplayEqualizer;
Global Group groupMiniDisplayThinger;
Global Group groupMiniDisplayVisualizer;
Global Layer layerMiniDisplayTransition;
Global Button buttonMiniDisplayNormal;
Global Button buttonMiniDisplayEqualizer;
Global Button buttonMiniDisplayThinger;
Global Button buttonMiniDisplayVisualizer;
Global String strMiniDisplayCurrentMode;
Global String strMiniDisplayTransitionStatus;

//Visualizers
Global AnimatedLayer layerMiniVisOne;
Global AnimatedLayer layerNormalVisOne;
Global Layer layerMiniVisBackground;
Global Timer timerVisReresh;
Global Int intVisMaxVuLevel;
Global Int intVisPreviousFrame;
Global Int intVisFrameDeclineRate;
Global Boolean boolNormalVisOneEnabled;

//Tips
Global Layout layoutTipsNormal;
Global Button buttonTipsPrevious;
Global Button buttonTipsNext;
Global ToggleButton buttonTipsMainMode;
Global ToggleButton buttonTipsMiniMode;
Global ToggleButton buttonTipsStickMode;
Global Group groupTipPages;
Global Int intTipsCount;
Global Int intCurrentTipIndex;
Global Int intTipsMainModeIndex;
Global Int intTipsMiniModeIndex;
Global Int intTipsStickModeIndex;