initStickDrawers() {
	groupStickDrawerPL = layoutMainStick.findObject("player.stick.group.drawerpl");
	groupStickDrawerConfig = layoutMainStick.findObject("player.stick.group.drawerconfig");
	layoutStickDrawerPLComponents = System.newGroupAsLayout("player.stick.group.drawerpl.layout");
	groupStickDrawerPLComponents = layoutStickDrawerPLComponents.findObject("player.stick.group.drawerpl.components");
	
	layerStickDrawerPLBackground = groupStickDrawerPL.findObject("player.background.drawerpl.main.top");
	layerStickDrawerConfigBackground = groupStickDrawerConfig.findObject("player.background.drawerconfig.main");
	
	buttonStickDrawerPLToggle = layoutMainStick.findObject("player.button.drawerpl");
	buttonStickDrawerConfigToggle = layoutMainStick.findObject("player.button.drawerconfig");
	
	layerStickDrawerPLToggle = layoutMainStick.findObject("player.button.drawerpl.knob");
	layerStickDrawerConfigToggle = layoutMainStick.findObject("player.button.drawerconfig.knob");
	
	layoutStickDrawerPLComponents.setXMLParam("x", "200");
	layoutStickDrawerPLComponents.setXMLParam("y", "23");
	layoutStickDrawerPLComponents.setXMLParam("w", "270");
	layoutStickDrawerPLComponents.setXMLParam("h", "198");
	layoutStickDrawerPLComponents.setXMLParam("default_w", "270");
	layoutStickDrawerPLComponents.setXMLParam("default_h", "198");
	layoutStickDrawerPLComponents.setXMLParam("minimum_w", "270");
	layoutStickDrawerPLComponents.setXMLParam("minimum_h", "198");
	
	Int intLayoutHeight = System.getPrivateInt(strSkinName, "LayoutMainStickHeight", 222);
	if (intLayoutHeight == 0 || intLayoutHeight == NULL) { intLayoutHeight = 222; }
	layoutMainStick.resize(layoutMainStick.getLeft(), layoutMainStick.getTop(), layoutMainStick.getWidth(), intLayoutHeight);
	
	intStickDrawerConfigPosYLow = 0;
	intStickDrawerConfigPosYHigh = -198;
	
	intStickDrawerPLPosYLow = 0;
	
	layoutStickDrawerPLComponents.hide();
	groupStickDrawerPL.hide();
	groupStickDrawerConfig.hide();
	
	timerTextStickSongNameSingleClick = new Timer;
	timerTextStickSongNameSingleClick.setDelay(250);
	
	groupStickDrawerPL.setXMLParam("y", System.integerToString((groupStickDrawerPL.getHeight() * -1)));
	
	strStickDrawerLastPosition = System.getPrivateString(strSkinName, "StickDrawer", "CLOSED");
	if (strStickDrawerLastPosition == "PL") { buttonStickDrawerPLToggle.leftClick(); }
	if (strStickDrawerLastPosition == "CONFIG") { buttonStickDrawerConfigToggle.leftClick(); }
}

unloadStickDrawers() {
	delete timerTextStickSongNameSingleClick;
}

layoutMainStick.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	Int intStickDrawerPLDockOffset = 24;
	layoutStickDrawerPLComponents.setXMLParam("h", System.integerToString(layoutMainStick.getHeight() - intStickDrawerPLDockOffset));
	System.setPrivateInt(strSkinName, "LayoutMainStickHeight", layoutMainStick.getHeight());
}

buttonStickDrawerPLToggle.onToggle(Boolean boolActivate) {
	if (boolActivate) {
		initStickDrawerPL();
		layerStickDrawerPLToggle.gotoFrame(1);
		layerStickDrawerConfigToggle.gotoFrame(0);
	} else {
		layerStickDrawerPLToggle.gotoFrame(0);
		layoutStickDrawerPLComponents.hide();
		closeStickDrawer(groupStickDrawerPL, (groupStickDrawerPL.getHeight() * -1));
	}
}

buttonStickDrawerConfigToggle.onToggle(Boolean boolActivate) {
	if (boolActivate) {
		initStickDrawerConfig();
		layerStickDrawerConfigToggle.gotoFrame(1);
		layerStickDrawerPLToggle.gotoFrame(0);
	} else {
		layerStickDrawerConfigToggle.gotoFrame(0);
		closeStickDrawer(groupStickDrawerConfig, intStickDrawerConfigPosYHigh);
	}
}

textStickSongName.onLeftButtonDown(Int intPosX, Int intPosY) {
	intTextStickSongNameLeftButtonDown = 1;
	timerTextStickSongNameSingleClick.start();
}

textStickSongName.onLeftButtonUp(Int intPosX, Int intPosY) {
	intTextStickSongNameLeftButtonDown = 0;
}

textStickSongName.onMouseMove(Int intPosX, Int intPosY) {
	if (intTextStickSongNameLeftButtonDown) {
		timerTextStickSongNameSingleClick.stop();
	}
}

timerTextStickSongNameSingleClick.onTimer() {
	timerTextStickSongNameSingleClick.stop();
	if (strStickDrawerLastPosition == "CLOSED") {
		initStickDrawerPL();
		layerStickDrawerPLToggle.gotoFrame(1);
		layerStickDrawerConfigToggle.gotoFrame(0);
	} else {
		layerStickDrawerPLToggle.gotoFrame(0);
		layoutStickDrawerPLComponents.hide();
		closeStickDrawer(groupStickDrawerPL, (groupStickDrawerPL.getHeight() * -1));
	}
}

groupStickDrawerPL.onTargetReached() {
	if (strStickDrawerLastPosition == "CONFIG" || strStickDrawerLastPosition == "CLOSED") {
		layoutStickDrawerPLComponents.hide();
		groupStickDrawerPL.hide();
	}
	if (strStickDrawerLastPosition == "PL") {
		layoutStickDrawerPLComponents.show();
		groupStickDrawerPLComponents.setFocus();
	}
	if (strStickDrawerLastPosition == "CONFIG") {
		groupStickDrawerConfig.show();
		animateDrawer(groupStickDrawerConfig, intStickDrawerConfigPosYLow, 1);
	}
}

groupStickDrawerConfig.onTargetReached() {
	if (strStickDrawerLastPosition == "PL" || strStickDrawerLastPosition == "CLOSED") {
		groupStickDrawerConfig.hide();
	}
	if (strStickDrawerLastPosition == "PL") {
		groupStickDrawerPL.show();
		animateDrawer(groupStickDrawerPL, intStickDrawerPLPosYLow, 1);
	}
}

initStickDrawerPL() {
	if (strStickDrawerLastPosition == "CONFIG") {
		buttonStickDrawerConfigToggle.setActivatedNoCallback(false);
		closeStickDrawer(groupStickDrawerConfig, intStickDrawerConfigPosYHigh);
	} else {
		groupStickDrawerPL.show();
		animateDrawer(groupStickDrawerPL, intStickDrawerPLPosYLow, 1);
	}
	strStickDrawerLastPosition = "PL";
	System.setPrivateString(strSkinName, "StickDrawer", strStickDrawerLastPosition);
}

initStickDrawerConfig() {
	if (strStickDrawerLastPosition == "PL") {
		buttonStickDrawerPLToggle.setActivatedNoCallback(false);
		layoutStickDrawerPLComponents.hide();
		closeStickDrawer(groupStickDrawerPL, (groupStickDrawerPL.getHeight() * -1));
	} else {
		groupStickDrawerConfig.show();
		animateDrawer(groupStickDrawerConfig, intStickDrawerConfigPosYLow, 1);
	}
	strStickDrawerLastPosition = "CONFIG";
	System.setPrivateString(strSkinName, "StickDrawer", strStickDrawerLastPosition);
}

closeStickDrawer(Group groupDrawer, Int intDrawerPosYClosed) {
	animateDrawer(groupDrawer, intDrawerPosYClosed, 1);
	strStickDrawerLastPosition = "CLOSED";
	System.setPrivateString(strSkinName, "StickDrawer", strStickDrawerLastPosition);
}

layerStickDrawerConfigBackground.onLeftButtonDblClk(Int intPosX, Int intPosY) {
	buttonStickDrawerConfigToggle.setActivatedNoCallback(false);
	layerStickDrawerConfigToggle.gotoFrame(0);
	closeStickDrawer(groupStickDrawerConfig, intStickDrawerConfigPosYHigh);
}

layerStickDrawerPLBackground.onLeftButtonDblClk(Int intPosX, Int intPosY) {
	buttonStickDrawerPLToggle.setActivatedNoCallback(false);
	layerStickDrawerPLToggle.gotoFrame(0);
	layoutStickDrawerPLComponents.hide();
	closeStickDrawer(groupStickDrawerPL, (groupStickDrawerPL.getHeight() * -1));
}