initGlobal() {
	containerMain = System.getContainer("main");
	
	layoutMainNormal = containerMain.getLayout("normal");
	layoutMainMini = containerMain.getLayout("mini");
	layoutMainStick = containerMain.getLayout("stick");
	
	textNormalSongTime = layoutMainNormal.findObject("player.display.time");
	textNormalSongName = layoutMainNormal.findObject("player.display.songname");
	textNormalSongInfo = layoutMainNormal.findObject("player.display.songinfo");
	textNormalActionInfo = layoutMainNormal.findObject("player.display.actioninfo");
	
	textMiniSongTime = layoutMainMini.findObject("player.display.time");
	textMiniSongName = layoutMainMini.findObject("player.display.songname");
	textMiniActionInfo = layoutMainMini.findObject("player.display.actioninfo");
	
	textStickSongTime = layoutMainStick.findObject("player.display.time");
	textStickSongName = layoutMainStick.findObject("player.display.songname");
	textStickActionInfo = layoutMainStick.findObject("player.display.actioninfo");
	
	textNormalActionInfo.hide();
	textMiniActionInfo.hide();
	textStickActionInfo.hide();
	
	mapNormalVolSeekLevel = new Map;
	mapNormalVolSeekRegion = new Map;
	mapNormalVolSeekLevel.loadMap("player.normal.background.volseek.map");
	mapNormalVolSeekRegion.loadMap("player.normal.background.volseek.region");
	
	mapMiniVolSeekLevel = new Map;
	mapMiniVolSeekRegion = new Map;
	mapMiniVolSeekLevel.loadMap("player.mini.background.volseek.map");
	mapMiniVolSeekRegion.loadMap("player.mini.background.volseek.region");
	
	mapStickVolSeekLevel = new Map;
	mapStickVolumeRegion = new Map;
	mapStickSeekRegion = new Map;
	mapStickVolSeekLevel.loadMap("player.stick.background.volseek.map");
	mapStickVolumeRegion.loadMap("player.stick.background.volume.region");
	mapStickSeekRegion.loadMap("player.stick.background.seek.region");
	
	regionVolSeekPosition = new Region;
	
	timerSongTicker = new Timer;
	timerSongTicker.setDelay(1000);
	boolReleaseSongTicker = true;
	
	strSkinName = System.getSkinName();
	
	boolSongTicker = System.getPrivateInt(strSkinName, "SongTicker", 1);
	setSongTicker();
}

unloadGlobal() {
	delete timerSongTicker;
	delete mapNormalVolSeekLevel;
	delete mapNormalVolSeekRegion;
	delete regionVolSeekPosition;
}

timerSongTicker.onTimer() {
	if (boolReleaseSongTicker) {
		textNormalActionInfo.hide();
		textNormalSongName.show();
		
		textMiniActionInfo.hide();
		textMiniSongName.show();
		
		textStickActionInfo.hide();
		textStickSongName.show();
		
		timerSongTicker.stop();
	}
}

showActionInfo(String strValue) {
	timerSongTicker.stop();
	timerSongTicker.start();
	
	textNormalSongName.hide();
	textNormalActionInfo.show();
	textNormalActionInfo.setText(strValue);
	
	textMiniSongName.hide();
	textMiniActionInfo.show();
	textMiniActionInfo.setText(strValue);
	
	textStickSongName.hide();
	textStickActionInfo.show();
	textStickActionInfo.setText(strValue);
}

setSongTicker() {
	textNormalSongName.setXMLParam("ticker", System.integerToString(boolSongTicker));
	textMiniSongName.setXMLParam("ticker", System.integerToString(boolSongTicker));
	textStickSongName.setXMLParam("ticker", System.integerToString(boolSongTicker));
	System.setPrivateInt(strSkinName, "SongTicker", boolSongTicker);
}

debugAlert(String strValue) {
	messageBox(strValue, "Debug Alert", 0, "");
}