initLights() {
	layerNormalLightsLeft = layoutMainNormal.findObject("player.background.lights.left");
	layerNormalLightsRight = layoutMainNormal.findObject("player.background.lights.right");
	layerNormalLightsHint = layoutMainNormal.findObject("player.background.lights.hint");
	
	strLightsCurrentMode = System.getPrivateString(strSkinName, "LightsMode", "PULSE");
	
	mapNormalLightsLevel = new Map;
	mapNormalLightsLevel.loadMap("player.normal.background.lights.region");
	
	regionNormalLightsLevel = new Region;
	
	timerLights = new Timer;
	timerLights.setDelay(50);
	if (strLightsCurrentMode != "OFF") {
		timerLights.start();
	}
}

unloadLights() {
	delete mapNormalLightsLevel;
	delete regionNormalLightsLevel;
	delete timerLights;
}

timerLights.onTimer() {
	if (layerNormalLightsHint.isVisible()) {
		visLightsUpdate(System.getLeftVuMeter(), System.getRightVuMeter());
	}
}

visLightsUpdate(Int intLeftValue, Int intRightValue) {
	if (strLightsCurrentMode == "PULSE") {
		visLightsUpdatePulse(intLeftValue, intRightValue);
	}
	if (strLightsCurrentMode == "LEVEL") {
		visLightsUpdateLevel(intLeftValue, intRightValue);
	}
	return;
}

visLightsUpdatePulse(Int intLeftValue, Int intRightValue) {
	if (intLeftValue > layerNormalLightsLeft.getAlpha()) {
		layerNormalLightsLeft.setAlpha(intLeftValue);
		layerNormalLightsLeft.setTargetA(0);
		layerNormalLightsLeft.setTargetSpeed(0.5);
		layerNormalLightsLeft.gotoTarget();
	}
	if (intRightValue > layerNormalLightsRight.getAlpha()) {
		layerNormalLightsRight.setAlpha(intRightValue);
		layerNormalLightsRight.setTargetA(0);
		layerNormalLightsRight.setTargetSpeed(0.5);
		layerNormalLightsRight.gotoTarget();
	}
}

visLightsUpdateLevel(Int intLeftValue, Int intRightValue) {
	layerNormalLightsLeft.setAlpha(255);
	regionNormalLightsLevel.loadFromMap(mapNormalLightsLevel, intLeftValue, 1);
	layerNormalLightsLeft.setRegion(regionNormalLightsLevel);
	
	layerNormalLightsRight.setAlpha(255);
	regionNormalLightsLevel.loadFromMap(mapNormalLightsLevel, intRightValue, 1);
	layerNormalLightsRight.setRegion(regionNormalLightsLevel);
}

layerNormalLightsHint.onRightButtonDown(Int intPosX, Int intPosY) {
	PopupMenu popupMenuLightsMode;
	
	popupMenuLightsMode = new PopupMenu;
	popupMenuLightsMode.addCommand("Light Modes", -1, 0, 1);
	popupMenuLightsMode.addSeparator();
	popupMenuLightsMode.addCommand("Pulse ", 0, (strLightsCurrentMode == "PULSE"), 0);
	popupMenuLightsMode.addCommand("Level ", 1, (strLightsCurrentMode == "LEVEL"), 0);
	popupMenuLightsMode.addCommand("Off ", 2, (strLightsCurrentMode == "OFF"), 0);
	
	Int intLightsModeSelectedOption = popupMenuLightsMode.popAtMouse();
	if (intLightsModeSelectedOption > -1) {
		if (intLightsModeSelectedOption == 0) {
			timerLights.stop();
			strLightsCurrentMode = "PULSE";
			visLightsUpdateLevel(255, 255);
			layerNormalLightsLeft.setAlpha(0);
			layerNormalLightsRight.setAlpha(0);
			timerLights.start();
		}
		if (intLightsModeSelectedOption == 1) {
			timerLights.stop();
			strLightsCurrentMode = "LEVEL";
			timerLights.start();
		}
		if (intLightsModeSelectedOption == 2) {
			timerLights.stop();
			strLightsCurrentMode = "OFF";
			layerNormalLightsLeft.setAlpha(0);
			layerNormalLightsRight.setAlpha(0);
		}
		System.setPrivateString(strSkinName, "LightsMode", strLightsCurrentMode);
	}
	complete;
	
	delete popupMenuLightsMode;
}