//Poppler Replacement2 script
//by Plague

#include <lib/std.mi>
#include <lib/config.mi>

Function toggleSearchLine();
Function toggleSelectionList();
Function openSidecar();
Function closeSidecar();
Function sendSelection(String msg);

Function attachTo(String edge);
Function saveValues();
Function getValues();
Function preventOversize();
Function String getEdge();
Function String getSavedValue(String obj, String val);

Global Group groupPopplerDivider;
Global Layer layerPopplerDivider;
Global Button poppler;
Global int in;
Global int sl;
Global Button searchlineclose;
Global Edit editcontrol;
Global Layout pllayout;
Global Group g, editor, sidecar;
Global Popupmenu settingsmenu;
Global Int choice;
Global Boolean leftdown, moved, editorin, changedlocation, save, locksize;
Global Text searchlabel;
Global Edit searchtext;

GLobal Int sidecar_oldpage, sidecar_wasopen;

System.onScriptUnloading() {
  if(!in) saveValues();
}

System.onScriptLoaded() {
  g = getScriptGroup();
  pllayout = g.getParentLayout();
  groupPopplerDivider = g.findObject("pledit.poppler.divider");
  layerPopplerDivider = g.findObject("pledit.divider");
  poppler = g.findObject("pledit.poppler");
  editor = g.findObject("pledit.editor.layout.pane");
  sidecar = g.findObject("pledit.sidecar.layout.pane");
  if(editor == NULL) editor = g.findObject("pledit.left");
  if(sidecar == NULL) sidecar = g.findObject("pledit.right");
  
  searchtext = g.findObject("pledit.search.text");
  searchlabel = g.findObject("pledit.search.label");
  
  settingsmenu = New PopupMenu;
  settingsmenu.addCommand("Poppler Settings",9,0,1);
  settingsmenu.addSeparator();
  settingsmenu.addCommand("Attach to right (default)",1,0,0);
  settingsmenu.addCommand("Attach to left",2,0,0);
  settingsmenu.addCommand("Attach to top",3,0,0);
  settingsmenu.addCommand("Attach to bottom",4,0,0);
  settingsmenu.addSeparator();
  settingsmenu.addCommand("Reset to default size",5,0,0);
  settingsmenu.addCommand("Lock to current size",6,0,0);


//get saved settings
  changedlocation = 0;
  save = 0;
  String edge = getEdge();
  if(edge != "") attachTo(edge);
  else attachTo("right");

  searchlineclose = g.findObject("searchline.close");
  GuiObject searchline = g.findObject("pledit.searchline");
  editcontrol = searchline.findObject("historyeditbox.edit");
  if (editcontrol == NULL) editcontrol = searchline;
  editorin = 0;
  editorin = getPrivateInt("pledit.poppler", "editorin", 0);
  locksize = 0;
  locksize = getPrivateInt("pledit.poppler", "locksize", 0);
  in = 0;
  sl = 0;
  String inout = getPrivateString("pledit.poppler", "inout", "out");
  if (inout == "in") poppler.onLeftButtonUp(0, 0);
  inout = getPrivateString("pledit.poppler", "searchline", "out");
  if (inout == "in") toggleSearchline();
}

attachTo(string edge){
  setPrivateString("pledit.poppler", "attach", edge);
  //reset all values, (default width/height/x/y)
  if(edge == "right"){
	editor.setXmlParam("relatx", "0"); editor.setXmlParam("relaty", "0"); editor.setXmlParam("relatw", "1"); editor.setXmlParam("relath", "1");
	editor.setXmlParam("x", "0"); editor.setXmlParam("y", "0"); editor.setXmlParam("w", "-138"); editor.setXmlParam("h", "0");

	sidecar.setXmlParam("relatx", "1"); sidecar.setXmlParam("relaty", "0"); sidecar.setXmlParam("relatw", "0"); sidecar.setXmlParam("relath", "1");
	sidecar.setXmlParam("x", "-130"); sidecar.setXmlParam("y", "0"); sidecar.setXmlParam("w", "130"); sidecar.setXmlParam("h", "0");
	
	groupPopplerDivider.setXmlParam("relatx", "1"); groupPopplerDivider.setXmlParam("relaty", "0"); groupPopplerDivider.setXmlParam("relatw", "0"); groupPopplerDivider.setXmlParam("relath", "1");
	groupPopplerDivider.setXmlParam("x", "-138"); groupPopplerDivider.setXmlParam("y", "-2"); groupPopplerDivider.setXmlParam("w", "8"); groupPopplerDivider.setXmlParam("h", "4");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.right");
	layerPopplerDivider.setXmlParam("image", "studio.framewnd.verticaldivider");
  }else if(edge == "left"){
	editor.setXmlParam("relatx", "0"); editor.setXmlParam("relaty", "0"); editor.setXmlParam("relatw", "1"); editor.setXmlParam("relath", "1");
	editor.setXmlParam("x", "138"); editor.setXmlParam("y", "0"); editor.setXmlParam("w", "-138"); editor.setXmlParam("h", "0");

	sidecar.setXmlParam("relatx", "0"); sidecar.setXmlParam("relaty", "0"); sidecar.setXmlParam("relatw", "0"); sidecar.setXmlParam("relath", "1");
	sidecar.setXmlParam("x", "0"); sidecar.setXmlParam("y", "0"); sidecar.setXmlParam("w", "130"); sidecar.setXmlParam("h", "0");
	
	groupPopplerDivider.setXmlParam("relatx", "0"); groupPopplerDivider.setXmlParam("relaty", "0"); groupPopplerDivider.setXmlParam("relatw", "0"); groupPopplerDivider.setXmlParam("relath", "1");
	groupPopplerDivider.setXmlParam("x", "130"); groupPopplerDivider.setXmlParam("y", "-2"); groupPopplerDivider.setXmlParam("w", "8"); groupPopplerDivider.setXmlParam("h", "4");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.left");
	layerPopplerDivider.setXmlParam("image", "studio.framewnd.verticaldivider");
  }else if(edge == "top"){
	editor.setXmlParam("relatx", "0"); editor.setXmlParam("relaty", "0"); editor.setXmlParam("relatw", "1"); editor.setXmlParam("relath", "1");
	editor.setXmlParam("x", "0"); editor.setXmlParam("y", "48"); editor.setXmlParam("w", "0"); editor.setXmlParam("h", "-48");

	sidecar.setXmlParam("relatx", "0"); sidecar.setXmlParam("relaty", "0"); sidecar.setXmlParam("relatw", "1"); sidecar.setXmlParam("relath", "0");
	sidecar.setXmlParam("x", "0"); sidecar.setXmlParam("y", "0"); sidecar.setXmlParam("w", "0"); sidecar.setXmlParam("h", "40");
	
	groupPopplerDivider.setXmlParam("relatx", "0"); groupPopplerDivider.setXmlParam("relaty", "0"); groupPopplerDivider.setXmlParam("relatw", "1"); groupPopplerDivider.setXmlParam("relath", "0");
	groupPopplerDivider.setXmlParam("x", "-2"); groupPopplerDivider.setXmlParam("y", "40"); groupPopplerDivider.setXmlParam("w", "4"); groupPopplerDivider.setXmlParam("h", "8");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.up");
	layerPopplerDivider.setXmlParam("image", "studio.framewnd.horizontaldivider");
  }else if(edge == "bottom"){
	editor.setXmlParam("relatx", "0"); editor.setXmlParam("relaty", "0"); editor.setXmlParam("relatw", "1"); editor.setXmlParam("relath", "1");
	editor.setXmlParam("x", "0"); editor.setXmlParam("y", "0"); editor.setXmlParam("w", "0"); editor.setXmlParam("h", "-48");

	sidecar.setXmlParam("relatx", "0"); sidecar.setXmlParam("relaty", "1"); sidecar.setXmlParam("relatw", "1"); sidecar.setXmlParam("relath", "0");
	sidecar.setXmlParam("x", "0"); sidecar.setXmlParam("y", "-40"); sidecar.setXmlParam("w", "0"); sidecar.setXmlParam("h", "40");

	groupPopplerDivider.setXmlParam("relatx", "0"); groupPopplerDivider.setXmlParam("relaty", "1");	groupPopplerDivider.setXmlParam("relatw", "1"); groupPopplerDivider.setXmlParam("relath", "0");
	groupPopplerDivider.setXmlParam("x", "-2"); groupPopplerDivider.setXmlParam("y", "-48"); groupPopplerDivider.setXmlParam("w", "4"); groupPopplerDivider.setXmlParam("h", "8");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.down");
	layerPopplerDivider.setXmlParam("image", "studio.framewnd.horizontaldivider");
  }

  if(getSavedValue("poppler", "x") == "" || changedlocation){
	editorin=0;
	saveValues();
	changedlocation = 0;
	if(in) closeSidecar();
	else{
		sidecar.show();
		setPrivateString("pledit.poppler", "inout", "out");
		in=0;
	}
  }else
	getValues();
}

saveValues(){
  setPrivateString("pledit.poppler", "editorx", editor.getXmlParam("x"));
  setPrivateString("pledit.poppler", "editory", editor.getXmlParam("y"));
  setPrivateString("pledit.poppler", "editorw", editor.getXmlParam("w"));
  setPrivateString("pledit.poppler", "editorh", editor.getXmlParam("h"));

  setPrivateString("pledit.poppler", "sidecarx", sidecar.getXmlParam("x"));
  setPrivateString("pledit.poppler", "sidecary", sidecar.getXmlParam("y"));
  setPrivateString("pledit.poppler", "sidecarw", sidecar.getXmlParam("w"));
  setPrivateString("pledit.poppler", "sidecarh", sidecar.getXmlParam("h"));

  setPrivateString("pledit.poppler", "popplerx", groupPopplerDivider.getXmlParam("x"));
  setPrivateString("pledit.poppler", "popplery", groupPopplerDivider.getXmlParam("y"));
  setPrivateString("pledit.poppler", "popplerw", groupPopplerDivider.getXmlParam("w"));
  setPrivateString("pledit.poppler", "popplerh", groupPopplerDivider.getXmlParam("h"));
  setPrivateString("pledit.poppler", "popplerimage", poppler.getXmlParam("image"));
  
  setPrivateInt("pledit.poppler", "editorin", editorin);
}

getValues(){
  editor.setXmlParam("x", getSavedValue("editor", "x"));
  editor.setXmlParam("y", getSavedValue("editor", "y"));
  editor.setXmlParam("w", getSavedValue("editor", "w"));
  editor.setXmlParam("h", getSavedValue("editor", "h"));

  sidecar.setXmlParam("x", getSavedValue("sidecar", "x"));
  sidecar.setXmlParam("y", getSavedValue("sidecar", "y"));
  sidecar.setXmlParam("w", getSavedValue("sidecar", "w"));
  sidecar.setXmlParam("h", getSavedValue("sidecar", "h"));
  
  groupPopplerDivider.setXmlParam("x", getSavedValue("poppler", "x"));
  groupPopplerDivider.setXmlParam("y", getSavedValue("poppler", "y"));
  groupPopplerDivider.setXmlParam("w", getSavedValue("poppler", "w"));
  groupPopplerDivider.setXmlParam("h", getSavedValue("poppler", "h"));
  poppler.setXmlParam("image", getSavedValue("poppler", "image"));

  editorin = getPrivateInt("pledit.poppler", "editorin", 0);
}

preventOversize(){
  String edge = getEdge();

  if(edge == "right"){
	if ( (g.getWidth() < 100 + groupPopplerDivider.getWidth() + sidecar.getWidth()) || editorin){
		int tmp0 = g.getWidth() - groupPopplerDivider.getWidth();
		groupPopplerDivider.setXmlParam("x", "-" + IntegerToString(g.getWidth()));
		editor.setXmlParam("w", "-" + IntegerToString(g.getWidth()));
		sidecar.setXmlParam("w", IntegerToString(tmp0));
		sidecar.setXmlParam("x", "-" + IntegerToString(tmp0));
		poppler.setXmlParam("image", "wasabi.button.label.arrow.right");
		layerPopplerDivider.setXmlParam("image", "studio.framewnd.verticaldivider");
		if(!sidecar.isVisible() && !in){
			getValues();
			sidecar.show();
			setPrivateString("pledit.poppler", "inout", "out");
			in = 0;
		}
		editorin=1;
	}
  }else if(edge == "left"){
	if ( (g.getWidth() < 100 + groupPopplerDivider.getWidth() + sidecar.getWidth()) || editorin){
		int tmp0 = g.getWidth() - groupPopplerDivider.getWidth();
		groupPopplerDivider.setXmlParam("x", IntegerToString(tmp0));
		sidecar.setXmlParam("w", IntegerToString(tmp0));
		editor.setXmlParam("w", "-" + IntegerToString(g.getWidth()));
		editor.setXmlParam("x", IntegerToString(tmp0));
		poppler.setXmlParam("image", "wasabi.button.label.arrow.left");
		layerPopplerDivider.setXmlParam("image", "studio.framewnd.verticaldivider");
		if(!sidecar.isVisible() && !in){
			getValues();
			sidecar.show();
			setPrivateString("pledit.poppler", "inout", "out");
			in = 0;
		}
		editorin=1;
	}
  }else if(edge == "top"){
	if ( (g.getHeight() < 30 + groupPopplerDivider.getHeight() + sidecar.getHeight()) || editorin){
		int tmp0 = g.getHeight() - groupPopplerDivider.getHeight();
		groupPopplerDivider.setXmlParam("y", IntegerToString(tmp0));
		sidecar.setXmlParam("h", IntegerToString(tmp0));
		editor.setXmlParam("h", "-" + IntegerToString(g.getHeight()));
		editor.setXmlParam("y", IntegerToString(tmp0));
		poppler.setXmlParam("image", "wasabi.button.label.arrow.up");
		layerPopplerDivider.setXmlParam("image", "studio.framewnd.horizontaldivider");
		if(!sidecar.isVisible() && !in){
			getValues();
			sidecar.show();
			setPrivateString("pledit.poppler", "inout", "out");
			in = 0;
		}
		editorin=1;
	}
  }else if(edge == "bottom"){
	if ( (g.getHeight() < 30 + groupPopplerDivider.getHeight() + sidecar.getHeight()) || editorin){
		int tmp0 = g.getHeight() - groupPopplerDivider.getHeight();
		groupPopplerDivider.setXmlParam("y", "-" + IntegerToString(g.getHeight()));
		editor.setXmlParam("h", "-" + IntegerToString(g.getHeight()));
		sidecar.setXmlParam("h", IntegerToString(tmp0));
		sidecar.setXmlParam("y", "-" + IntegerToString(tmp0));
		poppler.setXmlParam("image", "wasabi.button.label.arrow.down");
		layerPopplerDivider.setXmlParam("image", "studio.framewnd.horizontaldivider");
		if(!sidecar.isVisible() && !in){
			getValues();
			sidecar.show();
			setPrivateString("pledit.poppler", "inout", "out");
			in = 0;
		}
		editorin=1;
	}
  }
}

string getEdge(){
	return getPrivateString("pledit.poppler", "attach", "");
}

String getSavedValue(String obj, String val){
  //to get x, y, w, h values (or any other value that is) from studio.xnf
  return getPrivateString("pledit.poppler", obj+val, "");
}

openSidecar() {
  getValues();
  preventOversize();
  sidecar.show();
  setPrivateString("pledit.poppler", "inout", "out");
  in = 0;
}

CloseSidecar() {
  String edge = getEdge();
  
  if(edge == "right"){
	editor.setXmlParam("w", "-8");
	editor.setXmlParam("x", "0");
	sidecar.setXmlParam("w", "0");
	sidecar.setXmlParam("x", "-0");
	groupPopplerDivider.setXmlParam("x", "-8");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.left");
	layerPopplerDivider.setXmlParam("image", "studio.framewnd.verticaldivider");
  }else if(edge == "left"){
	editor.setXmlParam("w", "-8");
	editor.setXmlParam("x", "8");
	sidecar.setXmlParam("w", "0");
	sidecar.setXmlParam("x", "0");
	groupPopplerDivider.setXmlParam("x", "0");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.right");
	layerPopplerDivider.setXmlParam("image", "studio.framewnd.verticaldivider");
  }else if(edge == "top"){
	editor.setXmlParam("h", "-8");
	editor.setXmlParam("y", "8");
	sidecar.setXmlParam("h", "0");
	sidecar.setXmlParam("y", "0");
	groupPopplerDivider.setXmlParam("y", "0");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.down");
	layerPopplerDivider.setXmlParam("image", "studio.framewnd.horizontaldivider");
  }else if(edge == "bottom"){
	editor.setXmlParam("h", "-8");
	editor.setXmlParam("y", "0");
	sidecar.setXmlParam("h", "0");
	sidecar.setXmlParam("y", "-0");
	groupPopplerDivider.setXmlParam("y", "-8");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.up");
	layerPopplerDivider.setXmlParam("image", "studio.framewnd.horizontaldivider");
  }

  sidecar.hide();
  setPrivateString("pledit.poppler", "inout", "in");
  in = 1;
  editorin=0;
}

g.onResize(int x, int y, int w, int h){
  preventOversize();
}

poppler.onRightButtonUp(int x, int y){
	locksize = getPrivateInt("pledit.poppler", "locksize", 0);
	settingsmenu.checkCommand(1, (getEdge() == "right"));
	settingsmenu.checkCommand(2, (getEdge() == "left"));
	settingsmenu.checkCommand(3, (getEdge() == "top"));
	settingsmenu.checkCommand(4, (getEdge() == "bottom"));
	settingsmenu.checkCommand(6, locksize);

	choice = settingsmenu.popAtMouse();
	If (choice == 1){
		changedlocation = 1;
		attachTo("right");
	}else if (choice == 2){
		changedlocation = 1;
		attachTo("left");
	}else if (choice == 3){
		changedlocation = 1;
		attachTo("top");
	}else if (choice == 4){
		changedlocation = 1;
		attachTo("bottom");
	}else if (choice == 5){
		changedlocation = 1;
		attachTo(getEdge());
	}else if (choice == 6){
		if(locksize) locksize = false;
		else{
			locksize = true;
			messagebox("You have locked the Sidecar to it's current size.\nYou can override this lock anytime by pressing and\nholding SHIFT while resizing.", "Locked size", 0, "pledit_poppler_lock");
		}
		setPrivateInt("pledit.poppler", "locksize", locksize);
	}
	complete;
}

poppler.onLeftButtonDown(int x, int y){
	leftdown = 1;
	moved = 0;
}
poppler.onLeftButtonUp(int x, int y){
  if(leftdown && moved){
	if(save){ saveValues(); save = 0; }
	leftdown = 0;
	moved = 0;
	complete;
  }else{
	save = 0;
	leftdown = 0;
	moved = 0;
	if (in) openSidecar();
	else closeSidecar();
  }
}

g.onMouseMove(int x, int y){
  if((isKeyDown(VK_SHIFT) || !locksize) && leftdown) poppler.onMouseMove(x, y);
}
editor.onMouseMove(int x, int y){
  if((isKeyDown(VK_SHIFT) || !locksize) && leftdown) poppler.onMouseMove(x, y);
}
sidecar.onMouseMove(int x, int y){
  if((isKeyDown(VK_SHIFT) || !locksize) && leftdown) poppler.onMouseMove(x, y);
}

poppler.onMouseMove(int x, int y){
  String edge = getEdge();

  if(edge == "right"){
	x = x - (editor.getLeft()-(groupPopplerDivider.getWidth()/2));
	if((isKeyDown(VK_SHIFT) || !locksize) && leftdown && x > groupPopplerDivider.getWidth() && x < g.getWidth()){
		moved = 1;
		if(x > g.getWidth()-138 && x < g.getWidth()-122){
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			groupPopplerDivider.setXmlParam("x", "-138");
			editor.setXmlParam("w", "-138");
			sidecar.setXmlParam("w", "130");
			sidecar.setXmlParam("x", "-130");
			save = 1;
		}else if( x < 16 ){
			editorin=1;
			if(!sidecar.isVisible()) openSidecar();
			int tmp0 = g.getWidth() - groupPopplerDivider.getWidth();
			groupPopplerDivider.setXmlParam("x", "-" + IntegerToString(g.getWidth()));
			editor.setXmlParam("w", "-" + IntegerToString(g.getWidth()));
			sidecar.setXmlParam("w", IntegerToString(tmp0));
			sidecar.setXmlParam("x", "-" + IntegerToString(tmp0));
			save = 1;
		}else if( x > g.getWidth()-8 ){
			editorin=0;
			save = 0;
			closeSidecar();
		}else{
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			string tmp0 = IntegerToString(g.getWidth()-x+groupPopplerDivider.getWidth());
			string tmp1 = IntegerToString(g.getWidth()-x);
			groupPopplerDivider.setXmlParam("x", "-" + tmp0);
			editor.setXmlParam("w", "-" + tmp0);
			sidecar.setXmlParam("w", tmp1);
			sidecar.setXmlParam("x", "-" + tmp1);
			save = 1;
		}
	}
  }else if(edge == "left"){
	x = x - (sidecar.getLeft()-(groupPopplerDivider.getWidth()/2));
	if((isKeyDown(VK_SHIFT) || !locksize) && leftdown && x > groupPopplerDivider.getWidth() && x < g.getWidth()){
		moved = 1;
		if(x > 130 && x < 146){
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			groupPopplerDivider.setXmlParam("x", "130");
			sidecar.setXmlParam("w", "130");
			editor.setXmlParam("w", "-138");
			editor.setXmlParam("x", "138");
			save = 1;
		}else if( x > g.getWidth()-8 ){
			editorin=1;
			if(!sidecar.isVisible()) openSidecar();
			int tmp0 = g.getWidth() - groupPopplerDivider.getWidth();
			groupPopplerDivider.setXmlParam("x", IntegerToString(tmp0));
			sidecar.setXmlParam("w", IntegerToString(tmp0));
			editor.setXmlParam("w", "-" + IntegerToString(g.getWidth()));
			editor.setXmlParam("x", IntegerToString(tmp0));
			save = 1;
		}else if( x < 16 ){
			editorin=0;
			save = 0;
			closeSidecar();
		}else{
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			string tmp0 = IntegerToString(x-groupPopplerDivider.getWidth());
			groupPopplerDivider.setXmlParam("x", tmp0);
			sidecar.setXmlParam("w", tmp0);
			editor.setXmlParam("w", "-" + IntegerToString(x));
			editor.setXmlParam("x", IntegerToString(x));
			save = 1;
		}
	}
  }else if(edge == "top"){
	y = y - (sidecar.getTop()-(groupPopplerDivider.getHeight()/2));
	if((isKeyDown(VK_SHIFT) || !locksize) && leftdown && y > groupPopplerDivider.getHeight() && y < g.getHeight()){
		moved = 1;
		if(y > 40 && y < 56){
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			groupPopplerDivider.setXmlParam("y", "40");
			sidecar.setXmlParam("h", "40");
			editor.setXmlParam("h", "-48");
			editor.setXmlParam("y", "48");
			save = 1;
		}else if( y > g.getHeight()-8 ){
			editorin=1;
			if(!sidecar.isVisible()) openSidecar();
			int tmp0 = g.getHeight() - groupPopplerDivider.getHeight();
			groupPopplerDivider.setXmlParam("y", IntegerToString(tmp0));
			sidecar.setXmlParam("h", IntegerToString(tmp0));
			editor.setXmlParam("h", "-" + IntegerToString(g.getHeight()));
			editor.setXmlParam("y", IntegerToString(tmp0));
			save = 1;
		}else if( y < 16 ){
			editorin=0;
			save = 0;
			closeSidecar();
		}else{
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			string tmp0 = IntegerToString(y-groupPopplerDivider.getHeight());
			string tmp1 = IntegerToString(y);
			groupPopplerDivider.setXmlParam("y", tmp0);
			sidecar.setXmlParam("h", tmp0);
			editor.setXmlParam("h", "-" + tmp1);
			editor.setXmlParam("y", tmp1);
			save = 1;
		}
	}
  }else if(edge == "bottom"){
	y = y - (editor.getTop()-(groupPopplerDivider.getHeight()/2));
	if((isKeyDown(VK_SHIFT) || !locksize) && leftdown && y > groupPopplerDivider.getHeight() && y < g.getHeight()){
		moved = 1;
		if(y > g.getHeight()-48 && y < g.getHeight()-32){
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			groupPopplerDivider.setXmlParam("y", "-48");
			editor.setXmlParam("h", "-48");
			sidecar.setXmlParam("h", "40");
			sidecar.setXmlParam("y", "-40");
			save = 1;
		}else if( y < 16 ){
			editorin=1;
			if(!sidecar.isVisible()) openSidecar();
			int tmp0 = g.getHeight() - groupPopplerDivider.getHeight();
			groupPopplerDivider.setXmlParam("y", "-" + IntegerToString(g.getHeight()));
			editor.setXmlParam("h", "-" + IntegerToString(g.getHeight()));
			sidecar.setXmlParam("h", IntegerToString(tmp0));
			sidecar.setXmlParam("y", "-" + IntegerToString(tmp0));
			save = 1;
		}else if( y > g.getHeight()-8 ){
			editorin=0;
			save = 0;
			closeSidecar();
		}else{
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			string tmp0 = IntegerToString(g.getHeight()-y+groupPopplerDivider.getHeight());
			string tmp1 = IntegerToString(g.getHeight()-y);
			groupPopplerDivider.setXmlParam("y", "-" + tmp0);
			editor.setXmlParam("h", "-" + tmp0);
			sidecar.setXmlParam("h", tmp1);
			sidecar.setXmlParam("y", "-" + tmp1);
			save = 1;
		}
	}
  }
}

pllayout.onAccelerator(String action) {
  if (action == "jumper") {
    toggleSearchline();
    toggleSelectionList();
  }
}

toggleSearchLine() {
  GuiObject playlist = editor.findObject("pledit.editor");
  GuiObject searchline = editor.findObject("pledit.searchline");
  if (editor == NULL || searchline == NULL) return;
  TabSheet t = sidecar.findObject("pledit.sidecar");
  if (sl) {
    playlist.setXmlParam("h", "-23");  
    searchline.setXmlParam("y", "-23");  
    setPrivateString("pledit.poppler", "searchline", "out");
    searchline.show();
    editcontrol.setFocus();
    if (in) {
      openSidecar();
      sidecar_wasopen = 0;
    } else {
      sidecar_wasopen = 1; 
    }
    if (t.getCurPage() != 1) {
      sidecar_oldpage = t.getCurPage();
      t.setCurPage(1);
    } else {
      sidecar_oldpage = -1;
    }
    sl = 0;
  } else {
    searchline.hide();
    playlist.setXmlParam("h", "0");  
    searchline.setXmlParam("y", "0");  
    setPrivateString("pledit.poppler", "searchline", "in");
    searchline.onNotify("in", "", 0, 0);
    int page = t.getCurPage();
    if (!in) {
      if (page == 1) {
        if (sidecar_oldpage != -1) {
          t.setCurPage(sidecar_oldpage);
        }
      }
      if (page == 1 && !sidecar_wasopen) {
          closeSidecar();
      }
    }
    sl = 1;
  }
}

sendSelection(String msg) {
  GuiObject selwnd = sidecar.findObject("pledit.selection.window");
  if (selwnd != NULL) selwnd.sendAction(msg, "", 0, 0, 0, 0);
}

searchlineclose.onLeftClick() {
  toggleSearchline();
  messagebox("You have closed the Quick Selection box. This feature helps you\nfind and select specific items within a playlist. To access this\nfeature again, press the F3 key while the Playlist Editor window\nis active.", "Quick Selection", 0, "pledit_searchline_close");
}

editcontrol.onKeyDown(Int vkcode) {
  if (vkcode == VK_DOWN && isKeyDown(VK_CONTROL)) sendSelection("down");
  if (vkcode == VK_UP && isKeyDown(VK_CONTROL)) sendSelection("up");
  if (vkcode == 13 && isKeyDown(VK_CONTROL)) sendSelection("doubleclick");
}

searchtext.onEnter() {
  onIdleEditUpdate();
}

searchtext.onIdleEditUpdate() {
  Group g = getScriptGroup();
  GuiObject ed = g.findObject("pledit.editor");
  ed.setXmlParam("select", getText());
}

searchlabel.onLeftButtonDblClk(int x, int y) {
  searchtext.setText("");
  searchtext.onIdleEditUpdate();
}