//Poppler Replacement2 script, Invicta Edition
//by Plague

#include <lib/std.mi>
#include <lib/config.mi>

Function openSidecar();
Function closeSidecar();

Function attachTo(String edge);
Function saveValues();
Function getValues();
Function preventOversize();
Function String getEdge();
Function String getSavedValue(String obj, String val);

Global Button poppler;
Global int in;
Global Group g, editor, sidecar;
Global Popupmenu settingsmenu;
Global Int choice;
Global Boolean leftdown, moved, editorin, changedlocation, save, locksize;

Global Layout stick;

System.onScriptUnloading() {
  if(!in) saveValues();
}

System.onScriptLoaded(){
  stick = getContainer("main").getLayout("stick");
  g = stick.findObject("player.stick.group.drawerpl.components");
  poppler = stick.findObject("player.stick.group.drawerpl.divider");
  editor = stick.findObject("player.stick.group.drawerpl.editorgrp");
  sidecar = stick.findObject("player.stick.group.drawerpl.sidecargrp");

  settingsmenu = New PopupMenu;
  settingsmenu.addCommand("Poppler Settings",9,0,1);
  settingsmenu.addSeparator();
  settingsmenu.addCommand("Attach to top (default)",1,0,0);
  settingsmenu.addCommand("Attach to bottom",2,0,0);
  settingsmenu.addSeparator();
  settingsmenu.addCommand("Reset to default size",3,0,0);
  settingsmenu.addCommand("Lock to current size",4,0,0);


//get saved settings
  changedlocation = 0;
  save = 0;
  String edge = getEdge();
  if(edge != "") attachTo(edge);
  else attachTo("top");

  editorin = 0;
  editorin = getPrivateInt("invicta.poppler", "editorin", 0);
  locksize = 0;
  locksize = getPrivateInt("invicta.poppler", "locksize", 0);
  in = 0;
  String inout = getPrivateString("invicta.poppler", "inout", "out");
  if (inout == "in") poppler.onLeftButtonUp(0, 0);
}

attachTo(string edge){
  setPrivateString("invicta.poppler", "attach", edge);
  //reset all values, (default width/height/x/y)
  if(edge == "top"){
	editor.setXmlParam("relath", "1");
	editor.setXmlParam("x", "0"); editor.setXmlParam("y", "68"); editor.setXmlParam("w", "270"); editor.setXmlParam("h", "-83");

	sidecar.setXmlParam("relaty", "0");
	sidecar.setXmlParam("x", "0"); sidecar.setXmlParam("y", "0"); sidecar.setXmlParam("w", "270"); sidecar.setXmlParam("h", "60");

	poppler.setXmlParam("relaty", "0");
	poppler.setXmlParam("x", "-2"); poppler.setXmlParam("y", "60"); poppler.setXmlParam("w", "274"); poppler.setXmlParam("h", "8");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.up");
  }else if(edge == "bottom"){
	editor.setXmlParam("relath", "1");
	editor.setXmlParam("x", "0"); editor.setXmlParam("y", "0"); editor.setXmlParam("w", "270"); editor.setXmlParam("h", "-83");

	sidecar.setXmlParam("relaty", "1");
	sidecar.setXmlParam("x", "0"); sidecar.setXmlParam("y", "-75"); sidecar.setXmlParam("w", "270"); sidecar.setXmlParam("h", "60");

	poppler.setXmlParam("relaty", "1");
	poppler.setXmlParam("x", "-2"); poppler.setXmlParam("y", "-83"); poppler.setXmlParam("w", "274"); poppler.setXmlParam("h", "8");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.down");
  }

  if(getSavedValue("poppler", "x") == "" || changedlocation){
	editorin=0;
	saveValues();
	changedlocation = 0;
	if(in) closeSidecar();
	else{
		sidecar.show();
		setPrivateString("invicta.poppler", "inout", "out");
		in=0;
	}
  }else
	getValues();
}

saveValues(){
  setPrivateString("invicta.poppler", "editorx", editor.getXmlParam("x"));
  setPrivateString("invicta.poppler", "editory", editor.getXmlParam("y"));
  setPrivateString("invicta.poppler", "editorw", editor.getXmlParam("w"));
  setPrivateString("invicta.poppler", "editorh", editor.getXmlParam("h"));

  setPrivateString("invicta.poppler", "sidecarx", sidecar.getXmlParam("x"));
  setPrivateString("invicta.poppler", "sidecary", sidecar.getXmlParam("y"));
  setPrivateString("invicta.poppler", "sidecarw", sidecar.getXmlParam("w"));
  setPrivateString("invicta.poppler", "sidecarh", sidecar.getXmlParam("h"));

  setPrivateString("invicta.poppler", "popplerx", poppler.getXmlParam("x"));
  setPrivateString("invicta.poppler", "popplery", poppler.getXmlParam("y"));
  setPrivateString("invicta.poppler", "popplerw", poppler.getXmlParam("w"));
  setPrivateString("invicta.poppler", "popplerh", poppler.getXmlParam("h"));
  setPrivateString("invicta.poppler", "popplerimage", poppler.getXmlParam("image"));
  
  setPrivateInt("invicta.poppler", "editorin", editorin);
}

getValues(){
  editor.setXmlParam("x", getSavedValue("editor", "x"));
  editor.setXmlParam("y", getSavedValue("editor", "y"));
  editor.setXmlParam("w", getSavedValue("editor", "w"));
  editor.setXmlParam("h", getSavedValue("editor", "h"));

  sidecar.setXmlParam("x", getSavedValue("sidecar", "x"));
  sidecar.setXmlParam("y", getSavedValue("sidecar", "y"));
  sidecar.setXmlParam("w", getSavedValue("sidecar", "w"));
  sidecar.setXmlParam("h", getSavedValue("sidecar", "h"));

  poppler.setXmlParam("x", getSavedValue("poppler", "x"));
  poppler.setXmlParam("y", getSavedValue("poppler", "y"));
  poppler.setXmlParam("w", getSavedValue("poppler", "w"));
  poppler.setXmlParam("h", getSavedValue("poppler", "h"));
  poppler.setXmlParam("image", getSavedValue("poppler", "image"));

  editorin = getPrivateInt("invicta.poppler", "editorin", 0);
}

preventOversize(){
  String edge = getEdge();

  if(edge == "top"){
	if ( (g.getHeight() < 15 + poppler.getHeight() + sidecar.getHeight()) || editorin){
		int tmp0 = g.getHeight() - poppler.getHeight() - 15;
		poppler.setXmlParam("y", IntegerToString(tmp0));
		sidecar.setXmlParam("h", IntegerToString(tmp0));
		editor.setXmlParam("h", "-" + IntegerToString(g.getHeight()));
		editor.setXmlParam("y", IntegerToString(tmp0));
		poppler.setXmlParam("image", "wasabi.button.label.arrow.up");
		if(!sidecar.isVisible() && !in){
			getValues();
			sidecar.show();
			setPrivateString("invicta.poppler", "inout", "out");
			in = 0;
		}
		editorin=1;
	}
  }else if(edge == "bottom"){
	if ( (g.getHeight() < 15 + poppler.getHeight() + sidecar.getHeight()) || editorin){
		int tmp0 = g.getHeight() - poppler.getHeight();
		poppler.setXmlParam("y", "-" + IntegerToString(g.getHeight()));
		editor.setXmlParam("h", "-" + IntegerToString(g.getHeight()));
		sidecar.setXmlParam("h", IntegerToString(g.getHeight()-23));
		sidecar.setXmlParam("y", "-" + IntegerToString(tmp0));
		poppler.setXmlParam("image", "wasabi.button.label.arrow.down");
		if(!sidecar.isVisible() && !in){
			getValues();
			sidecar.show();
			setPrivateString("invicta.poppler", "inout", "out");
			in = 0;
		}
		editorin=1;
	}
  }
}

string getEdge(){
	return getPrivateString("invicta.poppler", "attach", "");
}

String getSavedValue(String obj, String val){
  //to get x, y, w, h values (or any other value that is) from studio.xnf
  return getPrivateString("invicta.poppler", obj+val, "");
}

openSidecar() {
  getValues();
  preventOversize();
  sidecar.show();
  setPrivateString("invicta.poppler", "inout", "out");
  in = 0;
}

CloseSidecar() {
  String edge = getEdge();
  
  if(edge == "top"){
	editor.setXmlParam("h", "-23");
	editor.setXmlParam("y", "8");
	sidecar.setXmlParam("h", "0");
	sidecar.setXmlParam("y", "0");
	poppler.setXmlParam("y", "0");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.down");
  }else if(edge == "bottom"){
	editor.setXmlParam("h", "-23");
	editor.setXmlParam("y", "0");
	sidecar.setXmlParam("h", "0");
	sidecar.setXmlParam("y", "-15");
	poppler.setXmlParam("y", "-23");
	poppler.setXmlParam("image", "wasabi.button.label.arrow.up");
  }

  sidecar.hide();
  setPrivateString("invicta.poppler", "inout", "in");
  in = 1;
  editorin=0;
}

g.onResize(int x, int y, int w, int h){
  preventOversize();
}

poppler.onRightButtonUp(int x, int y){
	locksize = getPrivateInt("invicta.poppler", "locksize", 0);
	settingsmenu.checkCommand(1, (getEdge() == "top"));
	settingsmenu.checkCommand(2, (getEdge() == "bottom"));
	settingsmenu.checkCommand(4, locksize);

	choice = settingsmenu.popAtMouse();
	if (choice == 1){
		changedlocation = 1;
		attachTo("top");
	}else if (choice == 2){
		changedlocation = 1;
		attachTo("bottom");
	}else if (choice == 3){
		changedlocation = 1;
		attachTo(getEdge());
	}else if (choice == 4){
		if(locksize) locksize = false;
		else{
			locksize = true;
			messagebox("You have locked the Sidecar to it's current size.\nYou can override this lock anytime by pressing and\nholding SHIFT while resizing.", "Locked size", 0, "invicta_poppler_lock");
		}
		setPrivateInt("invicta.poppler", "locksize", locksize);
	}
	complete;
}

poppler.onLeftButtonDown(int x, int y){
	leftdown = 1;
	moved = 0;
}
poppler.onLeftButtonUp(int x, int y){
  if(leftdown && moved){
	if(save){ saveValues(); save = 0; }
	leftdown = 0;
	moved = 0;
	complete;
  }else{
	save = 0;
	leftdown = 0;
	moved = 0;
	if (in) openSidecar();
	else closeSidecar();
  }
}

g.onMouseMove(int x, int y){
  if((isKeyDown(VK_SHIFT) || !locksize) && leftdown) poppler.onMouseMove(x, y);
}
editor.onMouseMove(int x, int y){
  if((isKeyDown(VK_SHIFT) || !locksize) && leftdown) poppler.onMouseMove(x, y);
}
sidecar.onMouseMove(int x, int y){
  if((isKeyDown(VK_SHIFT) || !locksize) && leftdown) poppler.onMouseMove(x, y);
}

poppler.onMouseMove(int x, int y){
  String edge = getEdge();

  if(edge == "top"){
	y = y - (sidecar.getTop()-(poppler.getHeight()/2));
	if((isKeyDown(VK_SHIFT) || !locksize) && leftdown && y > poppler.getHeight() && y < g.getHeight()){
		moved = 1;
		if(y > 60 && y < 76){
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			poppler.setXmlParam("y", "60");
			sidecar.setXmlParam("h", "60");
			editor.setXmlParam("h", "-83");
			editor.setXmlParam("y", "68");
			save = 1;
		}else if( y > g.getHeight()-23 ){
			editorin=1;
			if(!sidecar.isVisible()) openSidecar();
			int tmp0 = g.getHeight() - poppler.getHeight() - 15;
			poppler.setXmlParam("y", IntegerToString(tmp0));
			sidecar.setXmlParam("h", IntegerToString(tmp0));
			editor.setXmlParam("h", "-" + IntegerToString(g.getHeight()));
			editor.setXmlParam("y", IntegerToString(tmp0));
			save = 1;
		}else if( y < 16 ){
			editorin=0;
			save = 0;
			closeSidecar();
		}else{
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			string tmp0 = IntegerToString(y-poppler.getHeight());
			string tmp1 = IntegerToString(y);
			poppler.setXmlParam("y", tmp0);
			sidecar.setXmlParam("h", tmp0);
			editor.setXmlParam("h", "-" + IntegerToString(y+15));
			editor.setXmlParam("y", tmp1);
			save = 1;
		}
	}
  }else if(edge == "bottom"){
	y = y - (editor.getTop()-(poppler.getHeight()/2));
	if((isKeyDown(VK_SHIFT) || !locksize) && leftdown && y > poppler.getHeight() && y < g.getHeight()){
		moved = 1;
		if(y > g.getHeight()-83 && y < g.getHeight()-67){
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			poppler.setXmlParam("y", "-83");
			editor.setXmlParam("h", "-83");
			sidecar.setXmlParam("h", "60");
			sidecar.setXmlParam("y", "-75");
			save = 1;
		}else if( y < 16 ){
			editorin=1;
			if(!sidecar.isVisible()) openSidecar();
			int tmp0 = g.getHeight() - poppler.getHeight();
			poppler.setXmlParam("y", "-" + IntegerToString(g.getHeight()));
			editor.setXmlParam("h", "-" + IntegerToString(g.getHeight()));
			sidecar.setXmlParam("h", IntegerToString(g.getHeight()-23));
			sidecar.setXmlParam("y", "-" + IntegerToString(tmp0));
			save = 1;
		}else if( y > g.getHeight()-23 ){
			editorin=0;
			save = 0;
			closeSidecar();
		}else{
			editorin=0;
			if(!sidecar.isVisible()) openSidecar();
			string tmp0 = IntegerToString(g.getHeight()-y+poppler.getHeight());
			string tmp1 = IntegerToString(g.getHeight()-y);
			poppler.setXmlParam("y", "-" + tmp0);
			editor.setXmlParam("h", "-" + tmp0);
			sidecar.setXmlParam("h", IntegerToString(g.getHeight()-y-15));
			sidecar.setXmlParam("y", "-" + tmp1);
			save = 1;
		}
	}
  }
}

