initSeek() {
	layerNormalSeekSurface = layoutMainNormal.findObject("player.background.seek.track");
	layerNormalSeekGhost = layoutMainNormal.findObject("player.background.seek.handle");
	
	layerMiniSeekSurface = layoutMainMini.findObject("player.background.seek.track");
	layerMiniSeekGhost = layoutMainMini.findObject("player.background.seek.handle");
	
	layerStickSeekSurface = layoutMainStick.findObject("player.background.seek.track");
	layerStickSeekGhost = layoutMainStick.findObject("player.background.seek.handle");
	
	seekUpdate(0);
	
	timerSeek = new Timer;
	timerSeek.setDelay(150);
	timerSeek.start();
}

unloadSeek() {
	delete timerSeek;
}

seekUpdate(Int intNewPosition) {
	seekUpdateUtil(intNewPosition, mapNormalVolSeekRegion, layerNormalSeekGhost);
	seekUpdateUtil(intNewPosition, mapMiniVolSeekRegion, layerMiniSeekGhost);
	seekUpdateUtil(intNewPosition, mapStickSeekRegion, layerStickSeekGhost);
}

seekUpdateUtil(Int intNewPosition, Map mapSeekRegion, Layer layerSeekGhost) {
	Float floatPosition;
	Int intPlayItemLength = System.getPlayItemLength();
	if (intPlayItemLength == 0) {
		floatPosition = 0;
	} else {
		floatPosition = intNewPosition / intPlayItemLength * 255;
	}
	intCurrentPosition = floatPosition;
	seekUpdateRegion(layerSeekGhost, mapSeekRegion, floatPosition);
}

seekUpdateXY(Int intPosX, Int intPosY, Map mapSeekLevel, Map mapSeekRegion, Layer layerSeekGhost, Text textSongTicker, Text textSeekTicker) {
	Int intPosition = mapSeekLevel.getValue(intPosX, intPosY);
	seekUpdateRegion(layerSeekGhost, mapSeekRegion, intPosition);
	
	Float floatPositionPercentage = intPosition / 255 * 100;
	Float floatPlayItemLength = System.getPlayItemLength();
	Int intNewPosition = floatPlayItemLength * floatPositionPercentage / 100;
	showActionInfo(System.integerToTime(intNewPosition) + " / " + System.integerToTime(floatPlayItemLength));
}

seekUpdateRegion(Layer layerSeekGhost, Map mapSeekRegion, Float floatPosition) {
	regionVolSeekPosition.loadFromMap(mapSeekRegion, floatPosition, 1);
	layerSeekGhost.setRegion(regionVolSeekPosition);
}

timerSeek.onTimer() {
	if (intSeekClicked) return;
	Int intPlayItemLength = System.getPlayItemLength();
	if (intPlayItemLength > 0) {
		Int intPosition = System.getPosition() / intPlayItemLength * 255;
		if (intPosition != intCurrentPosition) {
			seekUpdate(System.getPosition());
		}
	} else {
		if (intCurrentPosition != 0) {
			seekUpdate(0);
			intCurrentPosition = 0;
		}
	}
}

seekMoveTo(Int intPosX, Int intPosY, Map mapSeekLevel) {
	Int intPosition = mapSeekLevel.getValue(intPosX, intPosY);
	System.seekTo(System.getPlayItemLength() * (intPosition / 255));
}

layerNormalSeekSurface.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerSeekSurfaceLeftButtonDownUtil(intPosX, intPosY, mapNormalVolSeekLevel, mapNormalVolSeekRegion, layerNormalSeekGhost, textNormalSongName, textNormalActionInfo);
}
layerMiniSeekSurface.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerSeekSurfaceLeftButtonDownUtil(intPosX, intPosY, mapMiniVolSeekLevel, mapMiniVolSeekRegion, layerMiniSeekGhost, textMiniSongName, textMiniActionInfo);
}
layerStickSeekSurface.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerSeekSurfaceLeftButtonDownUtil(intPosX, intPosY, mapStickVolSeekLevel, mapStickSeekRegion, layerStickSeekGhost, textStickSongName, textStickActionInfo);
}
layerSeekSurfaceLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapSeekLevel, Map mapSeekRegion, Layer layerSeekGhost, Text textSongTicker, Text textSeekTicker) {
	if (System.getPlayItemLength() <= 0) return;
	if (strLeft(System.getPlayItemString(), 4) == "http") return;
	intSeekClicked = 1;
	boolReleaseSongTicker = false;
	seekUpdateXY(intPosX, intPosY, mapSeekLevel, mapSeekRegion, layerSeekGhost, textSongTicker, textSeekTicker);
}

layerNormalSeekSurface.onMouseMove(Int intPosX, Int intPosY) {
	layerSeekSurfaceMouseMoveUtil(intPosX, intPosY, mapNormalVolSeekLevel, mapNormalVolSeekRegion, layerNormalSeekGhost, textNormalSongName, textNormalActionInfo);
}
layerMiniSeekSurface.onMouseMove(Int intPosX, Int intPosY) {
	layerSeekSurfaceMouseMoveUtil(intPosX, intPosY, mapMiniVolSeekLevel, mapMiniVolSeekRegion, layerMiniSeekGhost, textMiniSongName, textMiniActionInfo);
}
layerStickSeekSurface.onMouseMove(Int intPosX, Int intPosY) {
	layerSeekSurfaceMouseMoveUtil(intPosX, intPosY, mapStickVolSeekLevel, mapStickSeekRegion, layerStickSeekGhost, textStickSongName, textStickActionInfo);
}
layerSeekSurfaceMouseMoveUtil(Int intPosX, Int intPosY, Map mapSeekLevel, Map mapSeekRegion, Layer layerSeekGhost, Text textSongTicker, Text textSeekTicker) {
	if (intSeekClicked) {
		if (System.getPlayItemLength() == 0) {
			intSeekClicked = 0;
			boolReleaseSongTicker = true;
			return;
		}
		seekUpdateXY(intPosX, intPosY, mapSeekLevel, mapSeekRegion, layerSeekGhost, textSongTicker, textSeekTicker);
	}
}

layerNormalSeekSurface.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerSeekSurfaceLeftButtonUpUtil(intPosX, intPosY, mapNormalVolSeekLevel);
}
layerMiniSeekSurface.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerSeekSurfaceLeftButtonUpUtil(intPosX, intPosY, mapMiniVolSeekLevel);
}
layerStickSeekSurface.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerSeekSurfaceLeftButtonUpUtil(intPosX, intPosY, mapStickVolSeekLevel);
}
layerSeekSurfaceLeftButtonUpUtil(Int intPosX, Int intPosY, Map mapSeekLevel) {
	if (!intSeekClicked) return;
	intSeekClicked = 0;
	boolReleaseSongTicker = true;
	seekMoveTo(intPosX, intPosY, mapSeekLevel);
}