#include "../../../lib/std.mi"

Function centerWindowTitlebar();

Global Group groupWindow;
Global Group groupWindowTitlebar;
Global Button buttonPlay, buttonPause;

System.onScriptLoaded() {
	groupWindow = System.getScriptGroup();
	Layout layoutWindow = groupWindow.getParentLayout();
	groupWindowTitlebar = groupWindow.findObject("wasabi.titlebar.content");
	
	buttonPlay = groupWindow.findObject("window.button.play");
	buttonPause = groupWindow.findObject("window.button.pause");
	
	buttonPlay.hide();
	buttonPause.hide();
	
	if (System.stringToInteger(layoutWindow.getXMLParam("minimum_w")) < 335) {
		layoutWindow.setXMLParam("minimum_w", "335");
	}
	
	if (System.getPlayItemString() != "") {
		buttonPause.show();
	} else {
		buttonPlay.show();
	}
	
	centerWindowTitlebar();
}

groupWindow.onResize(Int intWidth, Int intHeight, Int intPosX, Int intPosY) {
	centerWindowTitlebar();
}

centerWindowTitlebar() {
	Int intWidthOffset = 100;
	groupWindowTitlebar.setXMLParam("x", System.integerToString((((groupWindow.getWidth() - intWidthOffset) - groupWindowTitlebar.getWidth()) / 2)));
}

System.onPlay() {
	buttonPlay.hide();
	buttonPause.show();
}

System.onPause() {
	buttonPlay.show();
	buttonPause.hide();
}

System.onStop() {
	buttonPlay.show();
	buttonPause.hide();
}

System.onResume() {
	buttonPlay.hide();
	buttonPause.show();
}
