#include "../../../lib/std.mi"

#include "declarations.m"
#include "global.m"
#include "drawers.m"
#include "pager.m"
#include "crossfader.m"
#include "custombuttons.m"
#include "lights.m"
#include "seek.m"
#include "volume.m"
#include "songtime.m"
#include "songinfo.m"
#include "behaviors.m"
#include "displays.m"
#include "visualizers.m"
#include "tips.m"

System.onScriptLoaded() {
	initGlobal();
	initDrawers();
	initPager();
	initCrossfader();
	initCustomButtons();
	initLights();
	initSeek();
	initVolume();
	initSongTime();
	initSongInfo();
	initBehaviors();
	initDisplays();
	initVisualizers();
	initTips();
}

System.onScriptUnloading() {
	unloadGlobal();
	unloadDrawers();
	unloadCrossfader();
	unloadLights();
	unloadSeek();
	unloadSongTime();
	unloadSongInfo();
	unloadBehaviors();
	unloadVisualizers();
}

System.onStop() {
	timerSongTime.stop();
	setSongTime(textNormalSongTime);
	setSongTime(textMiniSongTime);
	timerSongInfo.stop();
	textNormalSongInfo.setText("");
}

System.onPlay() {
	timerSongTime.start();
	timerSongInfo.start();
}

System.onResume() {
	timerSongTime.start();
	timerSongInfo.start();
}