initTips() {
	layoutTipsNormal = System.getContainer("tips").getLayout("normal");
	
	buttonTipsPrevious = layoutTipsNormal.findObject("tips.button.previous");
	buttonTipsNext = layoutTipsNormal.findObject("tips.button.next");
	buttonTipsMainMode = layoutTipsNormal.findObject("tips.button.mainmode");
	buttonTipsMiniMode = layoutTipsNormal.findObject("tips.button.minimode");
	buttonTipsStickMode = layoutTipsNormal.findObject("tips.button.stickmode");
	
	groupTipPages = layoutTipsNormal.findObject("tips.pages");
	
	intTipsCount = groupTipPages.getNumObjects();
	intCurrentTipIndex = 0;
	
	for (Int i = 0; i < intTipsCount; i++) {
		if (System.strUpper(getTipSection(i)) == "MAINMODE" && intTipsMainModeIndex == NULL) {
			intTipsMainModeIndex = i;
		} else if (System.strUpper(getTipSection(i)) == "MINIMODE" && intTipsMiniModeIndex == NULL) {
			intTipsMiniModeIndex = i;
		} else if (System.strUpper(getTipSection(i)) == "STICKMODE" && intTipsStickModeIndex == NULL) {
			intTipsStickModeIndex = i;
		}
		groupTipPages.enumObject(i).hide();
	}
	
	showTip(intCurrentTipIndex);
}

showTip(Int intTipIndex) {
	String strTipSection = getTipSection(intTipIndex);
	
	buttonTipsMainMode.setActivatedNoCallback(false);
	buttonTipsMiniMode.setActivatedNoCallback(false);
	buttonTipsStickMode.setActivatedNoCallback(false);	
	
	if (System.strUpper(strTipSection) == "MAINMODE") { buttonTipsMainMode.setActivatedNoCallback(true); }
	if (System.strUpper(strTipSection) == "MINIMODE") { buttonTipsMiniMode.setActivatedNoCallback(true); }
	if (System.strUpper(strTipSection) == "STICKMODE") { buttonTipsStickMode.setActivatedNoCallback(true); }
	
	for (Int i = 0; i < intTipsCount; i++) {
		if (i == intTipIndex) {
			groupTipPages.enumObject(i).show();
		} else {
			groupTipPages.enumObject(i).hide();
		}
	}
	
	intCurrentTipIndex = intTipIndex;
}

getTipSection(Int intTipIndex) {
	String strTipSection = groupTipPages.enumObject(intTipIndex).getID();
	strTipSection = System.strRight(strTipSection, System.strLen(strTipSection) - (System.strSearch(strTipSection, "-") + 1));
	return strTipSection;
}

buttonTipsPrevious.onLeftClick() {
	intCurrentTipIndex = intCurrentTipIndex - 1;
	if (intCurrentTipIndex < 0) {
		intCurrentTipIndex = (intTipsCount - 1);
	}
	showTip(intCurrentTipIndex);
}

buttonTipsNext.onLeftClick() {
	intCurrentTipIndex = intCurrentTipIndex + 1;
	if (intCurrentTipIndex > (intTipsCount - 1)) {
		intCurrentTipIndex = 0;
	}
	showTip(intCurrentTipIndex);
}

buttonTipsMainMode.onToggle(Boolean boolActivated) {
	if (System.strUpper(getTipSection(intCurrentTipIndex)) == "MAINMODE") {
		buttonTipsMainMode.setActivatedNoCallback(true);
	} else {
		showTip(intTipsMainModeIndex);
	}
}

buttonTipsMiniMode.onToggle(Boolean boolActivated) {
	if (System.strUpper(getTipSection(intCurrentTipIndex)) == "MINIMODE") {
		buttonTipsMiniMode.setActivatedNoCallback(true);
	} else {
		showTip(intTipsMiniModeIndex);
	}
}

buttonTipsStickMode.onToggle(Boolean boolActivated) {
	if (System.strUpper(getTipSection(intCurrentTipIndex)) == "STICKMODE") {
		buttonTipsStickMode.setActivatedNoCallback(true);
	} else {
		showTip(intTipsStickModeIndex);
	}
}