initVolume() {
	layerNormalVolumeSurface = layoutMainNormal.findObject("player.background.volume.track");
	layerNormalVolumeGhost = layoutMainNormal.findObject("player.background.volume.handle");

	layerMiniVolumeSurface = layoutMainMini.findObject("player.background.volume.track");
	layerMiniVolumeGhost = layoutMainMini.findObject("player.background.volume.handle");
	
	layerStickVolumeSurface = layoutMainStick.findObject("player.background.volume.track");
	layerStickVolumeGhost = layoutMainStick.findObject("player.background.volume.handle");
	
	volumeUpdate();
}

volumeUpdate() {
	volumeUpdateUtil(mapNormalVolSeekRegion, layerNormalVolumeGhost);
	volumeUpdateUtil(mapMiniVolSeekRegion, layerMiniVolumeGhost);
	volumeUpdateUtil(mapStickVolumeRegion, layerStickVolumeGhost);
}

volumeUpdateUtil(Map mapVolumeRegion, Layer layerVolumeGhost) {
	intCurrentVolume = System.getVolume();
	volumeUpdateRegion(layerVolumeGhost, mapVolumeRegion, intCurrentVolume);
}

volumeUpdateXY(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker) {
	Int intVolume = mapVolumeLevel.getValue(intPosX, intPosY) + 1;
	volumeUpdateRegion(layerVolumeGhost, mapVolumeRegion, intVolume);
	System.setVolume(intVolume - 1);
	volumeUpdateTicker(intVolume, textSongTicker, textVolumeTicker);
}

volumeUpdateRegion(Layer layerVolumeGhost, Map mapVolumeRegion, Float floatVolume) {
	regionVolSeekPosition.loadFromMap(mapVolumeRegion, floatVolume, 1);
	layerVolumeGhost.setRegion(regionVolSeekPosition);
}

volumeUpdateTicker(Int intVolume, Text textSongTicker, Text textVolumeTicker) {
	showActionInfo("Vol: " + System.integerToString(intVolume / 255 * 100) + "%");
}

layerNormalVolumeSurface.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerVolumeSurfaceLeftButtonDownUtil(intPosX, intPosY, mapNormalVolSeekLevel, mapNormalVolSeekRegion, layerNormalVolumeGhost, textNormalSongName, textNormalActionInfo);
}
layerMiniVolumeSurface.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerVolumeSurfaceLeftButtonDownUtil(intPosX, intPosY, mapMiniVolSeekLevel, mapMiniVolSeekRegion, layerMiniVolumeGhost, textMiniSongName, textMiniActionInfo);
}
layerStickVolumeSurface.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerVolumeSurfaceLeftButtonDownUtil(intPosX, intPosY, mapStickVolSeekLevel, mapStickVolumeRegion, layerStickVolumeGhost, textStickSongName, textStickActionInfo);
}
layerVolumeSurfaceLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker) {
	intVolumeClicked = 1;
	boolReleaseSongTicker = false;
	volumeUpdateXY(intPosX, intPosY, mapVolumeLevel, mapVolumeRegion, layerVolumeGhost, textSongTicker, textVolumeTicker);
}

layerNormalVolumeSurface.onMouseMove(Int intPosX, Int intPosY) {
	layerVolumeSurfaceMouseMoveUtil(intPosX, intPosY, mapNormalVolSeekLevel, mapNormalVolSeekRegion, layerNormalVolumeGhost, textNormalSongName, textNormalActionInfo);
}
layerMiniVolumeSurface.onMouseMove(Int intPosX, Int intPosY) {
	layerVolumeSurfaceMouseMoveUtil(intPosX, intPosY, mapMiniVolSeekLevel, mapMiniVolSeekRegion, layerMiniVolumeGhost, textMiniSongName, textMiniActionInfo);
}
layerStickVolumeSurface.onMouseMove(Int intPosX, Int intPosY) {
	layerVolumeSurfaceMouseMoveUtil(intPosX, intPosY, mapStickVolSeekLevel, mapStickVolumeRegion, layerStickVolumeGhost, textStickSongName, textStickActionInfo);
}
layerVolumeSurfaceMouseMoveUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker) {
	if (intVolumeClicked) {
		volumeUpdateXY(intPosX, intPosY, mapVolumeLevel, mapVolumeRegion, layerVolumeGhost, textSongTicker, textVolumeTicker);
	}
}

layerNormalVolumeSurface.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerVolumeSurfaceLeftButtonUpUtil(intPosX, intPosY);
}
layerMiniVolumeSurface.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerVolumeSurfaceLeftButtonUpUtil(intPosX, intPosY);
}
layerStickVolumeSurface.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerVolumeSurfaceLeftButtonUpUtil(intPosX, intPosY);
}
layerVolumeSurfaceLeftButtonUpUtil(Int intPosX, Int intPosY) {
	if (!intVolumeClicked) return;
	intVolumeClicked = 0;
	boolReleaseSongTicker = true;
}

System.onVolumeChanged(Int intVolume) {
	volumeUpdate();
	volumeUpdateTicker(intVolume, textNormalSongName, textNormalActionInfo);
	volumeUpdateTicker(intVolume, textMiniSongName, textMiniActionInfo);
	volumeUpdateTicker(intVolume, textStickSongName, textStickActionInfo);
}